; its my first 100%assembler program
; its REALLY old stuff :)

.MODEL SMALL
.CODE
.386
 ORG 100h
 NOSMART

 nPOINTS   EQU 16      ; Number of random points
 nSTAGES   EQU 32      ; Number of morph stages
                                        
 nSTEPS    EQU 64      ; 2^n             \
 NSA       EQU 10922   ;                  \ DON'T MESS WITH IT!
 NSB       EQU 43690   ;                  /
 STEP      EQU 1024    ; 65536 / STEPS   /

MAIN:
  jmp  Start           ; Jump to main code

  db   $-MAIN dup (8)  ; Force "type" command show BoRZoM and stop.
  db   'BoRZoM', 1Ah   ;

;-ROUTINES--------------------------------------------------------------------

UpdateBezier:          ; draws the bezier curve
  mov  ax, vPage       ; load es with pointer to virtual screen
  mov  es, ax
  xor  ax, ax
  mov  t1, ax
  mov  xx, ax
  mov  yy, ax
  xor  cx, cx
  mov  Color, 31       ; start drawing with color 31
BigLoop:
    push cx
    mov  i, cx
    mov  si, offset Buffer
    mov  bx, i
    shl  bx, 2
    add  si, bx
    inc  Color         ; increment color value (actually start with color 32)
   SmallLoop:
      mov  ax, t1
      mov  bx, ax
      mul  bx
      mov  ax, dx
      mov  t2, ax
      mul  t1
      mov  t3, dx
      mov  ax, t2
      mov  bx, t1
      sub  ax, bx
      sar  ax, 1
      add  ax, NSA
      push ax
      mov  ax, NSA
      mul  t3
      mov  bx, dx
      pop  ax
      sub  ax, bx
      mov  c1, ax
      mov  ax, t3
      shr  ax, 1
      add  ax, NSB
      sub  ax, t2
      mov  c2, ax
      mov  ax, t2
      add  ax, t1
      sub  ax, t3
      shr  ax, 1
      add  ax, NSA
      mov  c3, ax
      mov  ax, NSA
      mul  t3
      mov  c4, dx

      mov  ax, c1
      mov  bx, ds:[si]
      mul  bx
      push dx
      push ax
      mov  ax, c2
      mov  bx, ds:[si+4]
      mul  bx
      push dx
      push ax
      mov  ax, c3
      mov  bx, ds:[si+8]
      mul  bx
      push dx
      push ax
      mov  ax, c4
      mov  bx, ds:[si+12]
      mul  bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      shrd ax, dx, 16
      mov  xx, ax

      mov  ax, c1
      mov  bx, ds:[si+2]
      mul  bx
      push dx
      push ax
      mov  ax, c2
      mov  bx, ds:[si+6]
      mul  bx
      push dx
      push ax
      mov  ax, c3
      mov  bx, ds:[si+10]
      mul  bx
      push dx
      push ax
      mov  ax, c4
      mov  bx, ds:[si+14]
      mul  bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      pop  cx
      pop  bx
      add  ax, cx
      adc  dx, bx
      shrd ax, dx, 16

      mov  bx, ax
      shl  ax, 8
      shl  bx, 6
      add  bx, ax
      add  bx, xx
      mov  al, Color
      mov  es:[bx], al ; write pixel to screen

      mov  ax, t1
      add  ax, Step
      mov  t1, ax
   jnz  SmallLoop      ; t1 = 0? if not, repeat the loop
    pop  cx
    inc  cx
    cmp  cx, nPoints-4
  jnz  BigLoop         ; passed point limit? if not, repeat the loop
  ret
;ENDP

Random:    ; stolen from turbo pascal run-time library
  push cx
  push bx
  mov  ax, word ptr ds:[Seed]
  mov  bx, word ptr ds:[Seed+2]
  mov  cx, ax
  mul  Factor
  shl  cx, 3
  add  ch, cl
  add  dx, cx
  add  dx, bx
  shl  bx, 2
  add  dx, bx
  add  dh, bl
  shl  bx, 5
  add  dh, bl
  add  ax, 1
  adc  dx, 0
  mov  word ptr ds:[Seed], ax
  mov  word ptr ds:[Seed+2], dx
  pop  bx
  pop  cx
  xor  dx, dx
  div  bx
  mov  ax, dx
  ret
;ENDP

CalcPath:              ; generates random points in ds:si buffer
  mov  cx, nPOINTS-1
  mov  di, si
Init:
    mov   bx, 320
    call  Random
    mov   ds:[si], ax
    add   si, 2
    mov   bx, 190
    call  Random
    mov   ds:[si], ax
    add   si, 2
    dec   cx
  jnz  Init
  mov  ax, ds:[di]
  mov  ds:[si], ax
  mov  ax, ds:[di+2]
  mov  ds:[si+2], ax
  ret
;ENDP

CalcZero:              ; generates points at 160,100 in ds:si buffer
  mov  cx, nPOINTS
ZInit:
    mov   word ptr ds:[si], 160
    mov   word ptr ds:[si+2], 100
    add   si, 4
    dec   cx
  jnz  ZInit
  ret
;ENDP

UpdateScreen:          ; draws and clears virtual screen buffer
  mov  dx, 3dah
waitr:
  in   al, dx
  test al, 8
  jnz  waitr
waits:
  in   al, dx
  test al, 8
  jz   waits

  push ds
  mov  ax, 0A000h
  mov  es, ax
  mov  ax, vPage
  mov  ds, ax
  xor  di, di
  xor  si, si
  mov  cx, 16000
  rep  movsd
  mov  ax, vPage
  mov  es, ax
  xor  di, di
  mov  cx, 15200
  xor  eax, eax
  rep  stosd
  pop  ds
  ret
;ENDP

MoveData:              ; moves data from ds:si to ds:di cx bytes long
  push ds
  pop  es
  shr  cx, 2
  rep  movsd
  ret
;ENDP

Morph:                 ; does the actual morph
  mov  cx, nPOINTS*4
  mov  si, offset From
  mov  bx, offset To
  mov  di, offset Buffer
  MorphLoop:           ; NewX = (X2 - X1) * Stage / Stages + X1
    push cx
    mov  ax, ds:[bx]
    sub  ax, ds:[si]
    mov  cx, Stage
    mul  cx
    sar  ax, 6         ; 64 stages
    add  ax, ds:[si]
    mov  ds:[di], ax
    add  di, 2
    add  si, 2
    add  bx, 2
    pop  cx
    dec  cx
  jnz  MorphLoop
  ret
;ENDP

DrawLetter:            ; draws a letter on the screen
; es:di = screen coord
; al    = color
; ah    = character
  push ds
  push di
  push si
  push bx
  push ax
  mov  ax, FontSeg
  mov  ds, ax
  mov  si, cs:FontOfs
  xor  bx, bx
  pop  ax
  mov  bl, ah
  shl  bx, 3
  add  si, bx
  mov  cx, 8
  loopY:
    mov  bx, 128
    loopX:
      mov  ah, al
      test ds:[si], bl
      jnz  ZERO
      xor  al, al
    ZERO:
      stosb
      mov  al, ah
      shr  bx, 1
    jnz  loopX
    add  di, 312
    inc  si
    dec  cx
  jnz  loopY
  pop  bx
  pop  si
  pop  di
  pop  ds
  ret
;ENDP

UpdateWriter:          ; the scroller routine
  mov  ax, vPage
  mov  es, ax
  mov  di, 191*320
  mov  si, offset Text
  inc  Letter
  cmp  Letter, 57
  jnz  OK
  mov  FadeW, 1
  inc  Line
  mov  Letter, 1
  cmp  Line, nLINES
  jnz  OK
  mov  Line, 0

OK:
  mov  cx, Letter
  mov  bx, 40
  mov  ax, Line
  mul  bx
  add  si, ax
  xor  bx, bx

  WriteLoop:
    push cx
    mov  ah, ds:[si]
    mov  al, 31
    cmp  cx, 16
    ja   DrawHere
    cmp  bx, 40
    ja   SkipHere
    mov  al, cl
    add  al, 15

  DrawHere:
    call DrawLetter
    inc  si
  SkipHere:
    inc  bx
    add  di, 8
    pop  cx
    dec  cx
  jnz  WriteLoop
  ret
;ENDP

UpdateFade:
  mov  ax, 127
  inc  FadeW
  and  FadeW, ax
  cmp  FadeW, 118
  jb   Fuckout
  push ds
  mov  ax, vPage
  mov  ds, ax
  mov  es, ax
  mov  si, 191*320
  mov  di, 190*320
  mov  cx, 9*320
  call MoveData
  pop  ds
Fuckout:
  ret
;ENDP

;-MAIN CODE-------------------------------------------------------------------

Start:
  mov  ah, 4Ah         ; deallocate unused memory used by program
  mov  bx, 1000h       ; -"-
  int  21h             ; -"-
  jc   Error           ; -"-
  push cs
  pop  ds
  mov  ax, 1A00h       ; check for vga
  int  10h             ; -"-
  cmp  al, 1Ah         ; -"-
  je   vgaOK           ; -"-
  mov  ah, 9
  mov  dx, offset NoVGA
  int  21h
  mov  ax, 4CFFh
  int  21h

vgaOK:
  xor  ax, ax
  mov  ds, ax
  mov  eax, ds:[46Ch]  ; load random seed with timer value
  mov  Seed, eax
  mov  ax, cs
  mov  ds, ax
  mov  ax, 1130h       ; get 8x8 font pointer
  mov  bh, 1           ; -"-
  int  10h             ; -"-
  mov  FontSeg, es
  mov  FontOfs, bp
  mov  Stage, 0
  mov  ColorL, 0
  mov  si, offset From
  call CalcZero
  mov  si, offset To
  call CalcPath
  mov  ah, 48h         ; allocate 64k buffer for virtual screen
  mov  bx, 1000h       ; -"-
  int  21h             ; -"-
  jc   Error
  mov  vPage, ax
  mov  es, ax
  xor  di, di
  mov  cx, 16000
  xor  eax, eax
  rep  stosd
  mov  ax, 13h         ; init 320x200x256 mode
  int  10h             ; -"-
  mov  Line, 0
  mov  Letter, 0
  mov  FadeW, 0

MainLoop:
    call Morph
    call UpdateBezier
    cmp  FadeW, 0
    jnz  Fadeout
    call UpdateWriter
    jmp  Somewhere
  Fadeout:
    call UpdateFade
  Somewhere:
    call UpdateScreen

    inc  Stage
    cmp  Stage, nSTAGES
    jnz  Continue
    mov  Stage, 0
    mov  si, offset To
    mov  di, offset From
    mov  cx, nPOINTS*4
    call MoveData
    mov  si, offset To
    call CalcPath

Continue:
    mov  ah, 1
    int  16h
  jz   MainLoop

  mov  si, offset Buffer
  mov  di, offset From
  mov  cx, nPOINTS*4
  call MoveData
  mov  si, offset To
  call CalcZero
  mov  cx, nSTAGES
  mov  Stage, 0
  Fade:
    push cx
    call Morph
    call UpdateBezier
    call UpdateScreen
    inc  Stage
    pop  cx
    dec  cx
  jnz Fade

Quit:
  mov  ax, 03h
  int  10h
  mov  ah, 9
  mov  dx, offset Bye
  push cs
  pop  ds
  int  21h
  mov  ax, 4C00h
  int  21h

Error:
  mov  ah, 9
  mov  dx, offset NoMem
  push cs
  pop  ds
  int  21h
  mov  ax, 4CFFh
  int  21h

;-DATA------------------------------------------------------------------------

  NoMem   db 'Not enough memory.',              0Dh, 0Ah, 24h
  NoVGA   db 'VGA Required.',                   0Dh, 0Ah, 24h
  Bye     db 'Coded by BoRZoM / TroubleMakers, 1994', 0Dh, 0Ah, 24h

  Text    db '                WELCOME!                '
          db '   This tiny intro is coded by BoRZoM   '
          db '          in about two nights..         '
          db '    ..and the night after my computer   '
          db '   totally fucked up from a lightning!  '
          db '           Greetings goes to:           '
          db '    HEX  TREX  DR ENCRYPTION  RM     '
          db '  SHADOW MAN  TRUE COLOR  SID  RAVX  '
          db '                                        '
          db '            >>> WARPING <<<             '
          db '                                        '

  nLINES  EQU ($-Text)/40

          db 0
  Factor  dw 8405h

;-UNINITIALIZED DATA----------------------------------------------------------

  FontSeg dw ?
  FontOfs dw ?
  Color   db ?
  ColorL  db ?
  Line    dw ?
  Letter  dw ?
  FadeW   dw ?
  vPage   dw ?
  Stage   dw ?
  i       dw ?
  xx      dw ?
  yy      dw ?
  t1      dw ?
  t2      dw ?
  t3      dw ?
  c1      dw ?
  c2      dw ?
  c3      dw ?
  c4      dw ?
  Seed    dd ?
  To      dw nPOINTS*2 dup (?)  ; Point buffer for bezier curve.
  From    dw nPOINTS*2 dup (?)  ; the structure goes like this:
  Buffer  dw nPOINTS*2 dup (?)  ;   X1,Y1,X2,Y2...Xn,Yn (16bit)

END MAIN
