{$M 32768,0,655360}
{$G+,A+,R-,S-,O-,V+}

unit P_SMILEY;

{$DEFINE USEFILE}

interface

procedure Smiley;

implementation

Uses CRT, VGA, VGA3D, VGAVESA, VGAGIF, DOS, dtexture, sound, timer, fade, flcunit4;

{$I CARROT.INC}

var
  x, y, z : Integer;
  v0, v   : Vector;
  w,
  www,
  ww:integer;
  map1,map2,
  map3,
  b,
  p,p2     : Pointer;
  frame:Longint;
  sint:array[0..255]of shortint;
  shit:pointer;

type
  palarray=array[0..767] of byte;
  emo=array[0..6000] of byte;

var
  pal,pal2,tpal,RPal     : PalArray;
  comtable:^emo;

Function FindClosestColor(R,G,B:Shortint):Byte;
label lp;
Var CurColor,PalIndex:Word;
    Dist,TempDist:Word;
    Closest:Word;
Begin
 Dist:=$FFFF;PalIndex:=1;Closest:=0;
 For CurColor:=0 to 255 Do
  Begin
   TempDist:=Abs(RPal[PalIndex  ]-R)+
             Abs(RPal[PalIndex+1]-G)+
             Abs(RPal[PalIndex+2]-B);
   If TempDist<Dist then
      Begin
       Closest:=CurColor;
       If TempDist=0 then goto lp;
       Dist:=TempDist;
      End;
   Inc(PalIndex,3);
  End;
 Lp:FindClosestColor:=Closest;
End;

Procedure CreateCrossFadePalette(Var Pal1,Pal2:PalArray;Var ComPage:emo;
                                 Start1,Start2,End1,End2,V1:Word);
Const PhongStartGlaze=19;
Var index,c1,c2,c23,c13,c1base:Word;
    r,g,b,c1r,c1g,c1b:Integer;
    f: file;
begin
 {$IFNDEF USEFILE}
 RPal:=Pal1;
 Index:=0;c13:=1+Start1*3;
 For c1:=Start1 to End1 do
 Begin
  setrgb(0,c1,c1,c1);
  c1r:=Pal1[c13  ];
  c1g:=Pal1[c13+1];
  c1b:=Pal1[c13+2];
  Inc(c13,3);
  c23:=1+Start2*3;
  Index:=c1 Shl 8;
  For c2:=0 to PhongStartGlaze do
   begin
    ComPage[Index+c2]:=c1;
   end;
  For c2:=1+PhongStartGlaze to 32 do
   begin
    r:=c1r+(63-c1r)*(c2-1-PhongStartGlaze) div (32-PhongStartGlaze);
    g:=c1g+(63-c1g)*(c2-1-PhongStartGlaze) div (32-PhongStartGlaze);
    b:=c1b+(63-c1b)*(c2-1-PhongStartGlaze) div (32-PhongStartGlaze);
    ComPage[Index+c2]:=FindClosestColor(r,g,b);
   end;
 End;
  assign (f, f_sTable);
  rewrite (f, 1);
  blockwrite (f, comtable^, 65535);
  close (f);
 {$ELSE}
  assign (f, f_sTable);
  reset (f, 1);
  Blockread (f, comtable^, 65535);
  close (f);
 {$ENDIF}
End;

procedure _sync; far;
begin
 inc (frame, 1);
end;

procedure moved (p1,p2:pointer); assembler;
asm
 push ds
 lds si,p1
 les di,p2
 mov cx,64000
 @lp:
  mov al,ds:[si]
  or  al,al
  jz  @t
  mov es:[di],al
  @t:
  inc si
  inc di
  dec cx
 jnz @lp
 db $66; rep movsw
 pop ds
end;

var
  anim : Pointer;
  ap   : Pointer;

procedure Smiley;
Begin
  SetMode (g320x200, 320, 200, 1);
  maxx := 318;
  maxy := 198;

  GetMem (p, 65535);
  GetMem (ComTable, 65535);
  GetMem (ap, 65535);
  move (gifpalette, pal2, 768);
  map2 := LoadGIF (f_Phong1);
  move (gifpalette, pal, 768);
  loadflc (f_AnimSmily, anim, 0, 0);

  x := random (64); y := random (64); z := random (64);
  aTexture2Page := Seg (map2^);
  aCombineTable := Seg (ComTable^);
  aTargetPage := Seg (p^);
  CreateCrossFadePalette(Pal2,Pal,Comtable^,0,0,255,255,255);
  setpalette (pal2);
  TargetSegment := seg (ap^);
  PhisicalScreenWidth := 320;

  map1 := loadGIF (f_gSmile1);
  aTexture1Page := Seg (map1^);
  v.Init (nil,f_xSmily1);
  v.gravity(x,y,z);
  v.move(x,y,z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 512);
  v.SetMaterial (128, 128, NIL);
  v.SetAngle (0);
  ClearPage (p);
  for x:=0 to 255 do
    sint[x]:=round(sin(x*2*pi/128)*64);
  tmrSyncScr (Sync, @_sync, nil, nil);
  aTexture1Page := Seg (map1^);
  clearpage(ap);
  for x:=1 to 128 do begin
   ShowFLC (anim, x-1, x-1, 0);
   v.SetRotation (256, x*4 and 511, sint [x*4 and 255] and 511);
   v.Render;
   v.Project;
   moveD (ap,p);
   viewpage (p);
   clearpage(p);
  end;
  v.Done;
  Freemem (map1, 65535);
  map1 := LoadGIF (f_gSmile2);
  aTexture1Page := Seg (map1^);
  v.Init (nil,f_xSmily2);
  v.gravity(x,y,z);
  v.move(x,y,z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 512);
  v.SetMaterial (128, 128, NIL);
  v.SetAngle (0);
  ClearPage (p);
  ww:=0;
  initpalette(pal2);
  frame:=256;
  while frame < 512+64 do begin
   if frame>512 then fadepalette(64-(frame-512));
   clearpage(p);
   v.SetLocation (0, 0, 512+ww*40);
     inc(ww);
     www := (256+Frame*2)and 511;
   v.SetRotation (www, 0, 0);
   v.Render;
   v.Project;
   viewpage (p);
  end;
  v.Done;
  freemem (map1, 65535);
  tmrStopScrSync;
  ReleaseFLC (anim);
End;

End.