unit Sound;

Interface

var
  Sync : Word;

const
  playing:boolean=false;

procedure InitTimer;
procedure SoundConfig;
procedure SoundPlay;
procedure SoundStop;

Implementation

uses midas, mfile, mplayer, s3m, errors, mconfig, timer, dos;

{$I CARROT.INC}

var
  module : PmpModule;
  i, eror, isConfig : integer;
  str : array [0..256] of char;
  s   : Searchrec;

procedure InitTimer;
Begin
  asm
    mov ax, 13h
    int 10h
  end;
  tmrGetSCRsync (@sync);
End;

function Exist (n : String) : Boolean;
var
  f: File;
Begin
  Assign (f, n);
  {$I-} Reset (f, 1); {$I+}
  If IOResult=0 then Begin
    Exist := True;
    Close (f);
  End else Exist := False;
End;

procedure SoundConfig;
Begin
  midasSetDefaults;
  FindFirst ('CARROT.CFG', anyfile, s);
  If not Exist ('CARROT.CFG') then begin
    If MidasConfig = 0 then Halt else midasSaveConfig ('CARROT.CFG');
  End else midasLoadConfig ('CARROT.CFG');
  midasInit;
  module := midasLoadModule (f_MusicFile, @mpS3M, NIL);
End;

procedure SoundPlay;
Begin
  midasPlayModule (module, 0);
  playing:=true;
End;

procedure SoundStop;
Begin
  midasStopModule (module);
  midasFreeModule (module);
  midasClose;
End;

End.