//
// test program for mighty.engine
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include "engine.h"

void ViewPage (char *Buffer);
void ClearPage (char *Screen);
void setgraphmode ();
void settextmode ();

#pragma aux setgraphmode = \
  "mov  eax, 0x13"         \
  "int  10h"               ;

#pragma aux settextmode = \
  "mov  eax, 3"           \
  "int  10h"              ;

#pragma aux ViewPage = \
  "mov	ecx, 16000"    \
  "mov	edi, 0A0000h"  \
  "cli"                \
  "rep	movsd"         \
  "sti"                \
 modify [ecx edi]      \
 parm [esi]            ;

#pragma aux ClearPage =   \
  "cld"             \
  "mov  ecx, 16000" \
  "mov  eax, 0"     \
  "cli"             \
  "rep  stosd"      \
  "sti"             \
 modify [ecx eax]   \
 parm [edi]         ;

void setpalette ()
{
  int i;

  for (i=0; i<128; i++) {
    outp (0x3c8, i);
    outp (0x3c9, i>>1);
    outp (0x3c9, i>>1);
    outp (0x3c9, i>>1);
  }
}

char *texture = new char[65536];
char palette[768];

void inittexture ()
{
  FILE *in;
  int  x;
  in = fopen("texture.dat", "rb");
  if (in==NULL) exit(0);
  if (fread (&palette[0], 768, 1, in)!=1) exit (0);
  if (fread (texture, 65535, 1, in)!=1) exit (0);
  fclose (in);
  outp(0x3c8, 0);
  for (x=0; x<768; x++) outp(0x3c9, palette[x]);
}

void main ()
{
  Scene *world = new Scene;
  int i, j;
  Vector pos;

  InitEngine (320, 200);
  world->SetActive ();
  world->AmbientLight = 0.1;
  world->MaxIntensity = 127.0;
  printf("loading mesh file.\n");
  if (!LoadScene ("1.3ds")==1) {
   printf ("cannot load mesh file.\n");
   exit (0);
  }
  for (i=0;i<world->numObjects;i++)
    world->object[i]->SetShading (sf_plain, sh_gouraud, 0, 0, texture, texture);
  VirtualScreen = new char [64000];
  world->camera = world->cameras[0];
  world->sorttype = s_zmax;
  setgraphmode ();
//  inittexture ();
  setpalette ();
  world->keyframer->Prepare ();
  for (i=0; i<world->keyframer->numFrames; i++) {
    world->keyframer->NextFrame ();
    world->EyeSpace ();
    world->Display ();
    ViewPage (VirtualScreen);
    ClearPage (VirtualScreen);
    if (inp (0x60)==1) goto dogshit;
  }
dogshit:
  delete world;
  DoneEngine ();
  settextmode ();
}
