title   MAXIUM_64KB_INTRO
comment %        

  64kb movement96 intro compo
  
  i started this one week before mov96...here's the result :)
  nothing finished, everything sucks.. as usual.
  borzom                                                   

%                                
                                 
;
                                 
.386                             
.model small                     
.stack 2048                      
                                 
 o          equ offset           
 b          equ byte ptr         
 w          equ word ptr         
 d          equ dword ptr        
 scrnSeg    equ 0a000h      ; physical screen
 MixingRate equ 22000
 numPoints  equ 182
 numFaces   equ 360
 intensity  equ 6
 height     equ 384
 height2    equ height/2
 wcolor     equ 191
 density    equ 4

 movseg macro segment, address   
   push address                  
   pop  segment                  
 endm                            

 swapint macro i1, i2
   mov  ax, i1
   xchg ax, i2
   mov  i1, ax             
 endm
 
 point3d struc
   xp    dw ?                                          
   yp    dw ?
   zp    dw ?   
 point3d ends    
        
;
                                 
sound segment dword use16        
      assume  cs:sound           
                                 
init_sound proc far              
  push   ds                  
  mov    ax, sound           
  mov    ds, ax                
  call   LoadModule          
  jnc    NoLoadError         
  pop    ds                  
  mov    ax, data            
  mov    ds, ax              
  mov    ah, 9                    
  mov    dx, offset memory_error                       
  int    21h                 
  mov    ax, 4c00h           
  int    21h         
NoLoadError:          
  mov    MixSpeed, MixingRate
  call   AskConfig   
  pop    ds          
  ret                 
init_sound endp      
                           
play_sound proc far             
  push   ds
  mov    ax, sound  
  mov    ds, ax      
  call   StartPlayer  
  pop    ds          
  mov    ds:playing, 1
  ret                 
play_sound endp                   
                                                       
stop_sound proc far     
  cmp    ds:playing, 0  
  jz     nostop      
  push   ds             
  call   StopPlayer  
  call   FreeModule                  
  pop    ds          
nostop:              
  ret                
stop_sound endp                
                     
  INCLUDE     modplay.inc                         
  modoffset   dw ?  
                  
sound ends        
                  
;
                                                
code segment dword use16          
     assume  cs:code, ds:data                          
                                                
MAIN:                                           
  mov    StackSegment, ss     
  mov    StackPointer, sp     
  mov    ax, 4a00h                              
  mov    bx, 12800 ; 192kb for program
  int    21h      
;[init]
  call   system_init                            
  call   mandel_init       
  call   phong_init     
  call   tunnel_init    
  call   bump_init  
  call   tile_init
  call   sine_init    
  call   grafix_init
;[party text]  
  jmp    start_here
  mov    es, virtseg
  call   zero_fill
  mov    si, o party_text
  mov    cx, 6    
  xor    di, di  
ptextloop:        
    push   cx     
    xor    al, al  
    call   draw_textbig
    add    di, 10240
    pop    cx     
    dec    cx     
  jnz    ptextloop
  call   fadein
  mov    cx, 70*10
ptextwait:
    call  wait_retrace
  loop   ptextwait  
  call   fadeout      
  call   play_sound 
  mov    si, o palette_data
  call   set_palette
;[the end]
  mov    ax, virtseg 
  mov    es, ax      
  call   zero_fill   
  mov    di, 132+96*320
  mov    si, o end_text
  mov    al, 191     
  call   draw_text                    
  call   fadein      
  mov    cx, 70*6 
  call   delay     
  call   fadeout                          
;[credits scroll]
  call   grafix_initx                     
  mov    si, o palette_data
  call   set_palette 
  mov    cx, scroll_lines      
  mov    si, o credits_scroll  
  mov    ax, scrnseg              
  mov    es, ax                                        
  mov    edi, 320*200
scroll_init:         
    push  cx         
    push  si         
    push  edi        
    mov   al, 127    
    call  draw_textX 
    pop   edi        
    pop   si         
    pop   cx               
    add   edi, 320*8
    add   si, 40     
    dec   cx      
  jnz    scroll_init           
  mov    cx, (scroll_lines+25)*8
  xor    bx, bx                
the_scroller:                  
    push   bx                
    push   cx     
    cli                                                
    call   set_offset        
    sti                      
    call   wait_retrace      
    call   wait_retrace
    call   wait_retrace 
    call   wait_retrace    
    pop    cx                
    pop    bx                
    add    bx, 80              
    dec    cx                  
  jnz    the_scroller          
  mov    bx, 6                 
  mov    cx, 21h               
  call   wait_pattern          
  mov    ax, virtseg           
  mov    es, ax                
  call   zero_fill   
  call   flash     
;[vector part]
start_here:
  call   grafix_init
  mov    si, o glass_palette
  call   set_palette 
  mov    bx, xhandle6
  mov    ax, virtseg 
  mov    es, ax      
  call   xms_get     
  mov    bx, 6             
  mov    cx, 29h               
  call   wait_pattern          
  mov    bx, 240           
  call   draw_offset             
  mov    bx, 6             
  mov    cx, 2dh           
  call   wait_pattern      
  mov    bx, 160           
  call   draw_offset       
  mov    bx, 6             
  mov    cx, 31h           
  call   wait_pattern             
  mov    bx, 80                                        
  call   draw_offset       
  mov    bx, 6             
  mov    cx, 35h           
  call   wait_pattern      
  call   draw_screen
  mov    bx, xhandle6
  mov    es, dataseg1          
  call   xms_get               
  movseg es, ds      
  mov    si, o vector_vert4
  mov    bx, o vector_vert1
  mov    mfrom, si
  mov    mto, bx
  mov    stage, 0 
  call   vec_morph
  mov    lx, -800          
  mov    ly, 0           
  mov    lz, 640   
  mov    rx, 0           
  mov    ry, 0           
  mov    rz, 0           
  mov    bx, 7         
  mov    cx, 1         
  call   wait_pattern  
  cli                    
  mov    user_routine, o vector_timer_routine1
  sti                          
vecloop1:                
    push   ds            
    mov    es, virtseg   
    mov    ds, dataseg1  
    xor    si, si          
    xor    di, di        
    mov    cx, 16000     
    rep    movsd         
    pop    ds            
    call   vec_render    
    call   vec_project   
    call   draw_glasses
    call   draw_screen 
    cmp    lx, 0          
  jl     vecloop1         
  cli                     
  mov    user_routine, o vector_timer_routine2
  sti                     
vecloop2:                 
    push   ds             
    mov    es, virtseg         
    mov    ds, dataseg1   
    xor    si, si         
    xor    di, di         
    mov    cx, 16000      
    rep    movsd          
    pop    ds          
    mov    si, mfrom   
    mov    bx, mto     
    call   vec_morph   
    call   vec_render     
    call   vec_project    
    call   draw_glasses
    call   draw_screen 
    mov    ax, sound      
    mov    es, ax         
    cmp    es:OrderPos, 8
  jnz    vecloop2       
  call   initflashfade  
vecloop3:                 
    call   flashfade     
    push   ds                  
    mov    es, virtseg    
    mov    ds, dataseg1   
    xor    si, si         
    xor    di, di         
    mov    cx, 16000      
    rep    movsd          
    pop    ds             
    mov    si, mfrom   
    mov    bx, mto     
    call   vec_morph   
    call   vec_render     
    call   vec_project    
    call   draw_fx
    call   draw_glasses
    call   draw_screen
    mov    ax, sound      
    mov    es, ax         
    cmp    es:OrderPos, 10
  jnz    vecloop3      
  call   initflashfade 
vecloop4:              
    call   flashfade           
    push   ds             
    mov    es, virtseg    
    mov    ds, dataseg1                
    xor    si, si         
    xor    di, di         
    mov    cx, 16000      
    rep    movsd          
    pop    ds             
    mov    si, mfrom   
    mov    bx, mto     
    call   vec_morph   
    call   vec_render     
    call   vec_project    
    call   draw_glasses
    call   draw_screen 
    mov    ax, sound      
    mov    es, ax         
    cmp    es:OrderPos, 10
    jnz    vecloop4    
    cmp    es:Row, 3Fh                                                        
  jl     vecloop4      
  mov    user_routine, o null_routine
;[vector balls]
  mov    bx, 11        
  mov    cx, 1         
  call   wait_pattern   
  movseg es, virtseg   
  call   zero_fill     
  call   flash         
;[sonic]
  mov    es, dataseg1
  call   zero_fill
  mov    si, o greets_text1
  mov    di, 16*320
  xor    al, al 
  call   draw_textbig
  mov    si, o greets_text2
  mov    di, 64*320
  xor    al, al                                                               
  call   draw_textbig 
  mov    es, virtseg  
  call   zero_fill
  mov    cx, 200
  mov    x, -40       
  xor    bx, bx                        
  mov    y, 16        
  mov    w sprites[0], o sprite_sonic1
  mov    w sprites[2], o sprite_sonic2
  mov    w sprites[4], o sprite_sonic3
  mov    w sprites[6], o sprite_sonic4
sonic1:               
    push   cx                           
    push   bx                           
    mov    ax, spritedata               
    mov    fs, ax                       
    shr    bx, 2                        
    add    bx, bx                       
    mov    si, sprites[bx]              
    mov    es, virtseg                                                        
    add    x, 2 
    call   put_sprite2
    call   draw_screen                  
    call   wait_retrace                 
    pop    bx                           
    pop    cx                           
    inc    bx                           
    and    bx, 15                       
    dec    cx                           
  jnz    sonic1 
  mov    cx, 200
  mov    x, -40  
  xor    bx, bx                        
  mov    y, 16+16+32
sonic2:         
    push   cx                           
    push   bx                           
    mov    ax, spritedata               
    mov    fs, ax                       
    shr    bx, 2                                                              
    add    bx, bx                                                             
    mov    si, sprites[bx]                                                    
    mov    es, virtseg                                                        
    add    x, 2                                                               
    call   put_sprite2
    call   draw_screen                  
    call   wait_retrace                 
    pop    bx                           
    pop    cx                           
    inc    bx                           
    and    bx, 15                       
    dec    cx                           
  jnz    sonic2
  call   fadeout
;[greetings bump]
  
;
  mov    cx, 70*120                                                           
  call   delay                                                                
;
  jmp    system_shutdown                                                      
                                                                              
;
        
vector_timer_routine1:                                                        
;
  add    lx, 4                                                                
  mov    ax, rx  
  add    ax, 2 
  and    ax, 255
  mov    rx, ax
  mov    ax, ry
  add    ax, 1                 
  and    ax, 255
  mov    ry, ax 
  ret              
                        
vector_timer_routine2:
;
  mov    ax, rx           
  add    ax, 2  
  and    ax, 255
  mov    rx, ax      
  mov    ax, ry 
  add    ax, 1  
  and    ax, 255      
  mov    ry, ax       
  mov    ax, stage
  inc    ax     
  and    ax, 31   
  mov    stage, ax
  or     ax, ax
  jnz    trexit   
  mov    ax, mfrom             
  cmp    ax, o vector_vert1
  je     vm1      
  cmp    ax, o vector_vert2 
  je     vm2                
  cmp    ax, o vector_vert3 
  je     vm3                
  cmp    ax, o vector_vert4 
  je     vm4                
vm1:                        
  mov    mfrom, o vector_vert2
  mov    mto,   o vector_vert3                         
  jmp    trexit             
vm2:                        
  mov    mfrom, o vector_vert3
  mov    mto,   o vector_vert4
  jmp    trexit               
vm3:                        
  mov    mfrom, o vector_vert4
  mov    mto,   o vector_vert1            
  jmp    trexit                
vm4:                         
  mov    mfrom, o vector_vert1 
  mov    mto,   o vector_vert2 
trexit:                      
  ret                        

;
                                                                              
  INCLUDE general.inc                           
; INCLUDE effects.inc                                  
  INCLUDE engine.inc 
  INCLUDE grafix.inc
                                           
code ends                                  
                                           
;
                        
moredata segment dword use16
                    
  INCLUDE \assembly\maxium\inc\glasses.inc
  INCLUDE \assembly\maxium\inc\font2.inc
                                          
moredata ends       
                  
spritedata segment dword use16
             
  INCLUDE \assembly\maxium\inc\sonic1.inc
  INCLUDE \assembly\maxium\inc\sonic2.inc
  INCLUDE \assembly\maxium\inc\sonic3.inc
  INCLUDE \assembly\maxium\inc\sonic4.inc
  INCLUDE \assembly\maxium\inc\digger1.inc
  INCLUDE \assembly\maxium\inc\digger2.inc
  INCLUDE \assembly\maxium\inc\digger3.inc
  INCLUDE \assembly\maxium\inc\pcman1.inc
  INCLUDE \assembly\maxium\inc\pcman2.inc
  INCLUDE \assembly\maxium\inc\pcman3.inc
  INCLUDE \assembly\maxium\inc\ball.inc
                      
spritedata ends       
                                              
data segment dword use16                        
                                                
    memory_error db 'maxium: not enough memory!',     0Dh, 0Ah, 24h
       xms_error db 'maxium: not enough xms memory!', 0Dh, 0Ah, 24h
       vga_error db 'maxium: vga required!',          0Dh, 0Ah, 24h
    loading_text db 0Dh, 0Ah                  
                 db 'maxium: please wait...',         24h 
        end_text db 'THE END', 0
       exit_text db '                                 - maxium -', 0Dh, 0Ah
                 db '                               party  version', 0Dh, 0Ah
                 db 0Dh, 0Ah                           
                 db '          code:   BoRZoM                      design: BoRZoM', 0Dh, 0Ah
                 db '          grafix: StickyBaboon/Vlad/Phanatik  music:  MentalTrip', 0Dh, 0Ah
                 db 0Dh, 0Ah                          
                 db '     :maxium: sixty four k intro, started four days before movement''96.', 0Dh, 0Ah
                 db '         distribute freely. do not sell. do not change. just watch.', 0Dh, 0Ah
                 db 0Dh, 0Ah, 24h
   party_text    db 'THIS INTRO', 0
                 db 'WRITTEN IN', 0
                 db 'FOUR  DAYS', 0
                 db 'IN   OTHER', 0
                 db 'WORDS     ', 0
                 db 'IT   SUCKS', 0
  credits_scroll db '     THIS INTRO HAS REACHED ITS END     ' 
                 db '       AND HERE GOES THE CREDITS.       ' 
                 db '                                        ' 
                 db '          CODING BY BORZOM              '
                 db '           MUSIC BY MENTALTRIP          ' 
                 db '        GRAPHICS BY STICKYBABOON        ' 
                 db '                    VLAD                ' 
                 db '                    PHANATIK            ' 
		 db '         SOUNDSYSTEM: TINYPLAY          '
                 db '                                        '   
                 db '       WHY THIS NAME? I DONT KNOW       ' 
                 db '      WE ARE PROBABLY SCREWD UP..       ' 
                 db '           WHY WE SCREWD UP?            ' 
                 db '             I DONT KNOW..              ' 
                 db '                                        ' 
                 db '        I HAD 2 HARDDISK CRASHES        ' 
                 db '         THIS MONTH, SO NO DEMO         ' 
                 db '              THIS TIME..               ' 
                 db '                                        ' 
                 db '           THIS INTRO STARTED           ' 
                 db '       ONE WEEK BEFORE THE COMPO        ' 
                 db '                                        ' 
                 db '       NO HARM WAS CAUSED TO ANY        ' 
                 db '       PERSON WHILE WRITING THIS        ' 
                 db '       INTRO. TWO KEYBOARDS WERE        ' 
                 db '             BROKEN THOUGH.             ' 
                 db '                                        ' 
                 db '              BY THE WAY..              ' 
                 db '   YOU ARE FREE TO PRESS ESC ANY TIME   ' 
                 db 0                                          
    scroll_lines equ ($-credits_scroll)/40                     
    greets_text1 db 'GREETINGS ', 0
    greets_text2 db '        TO', 0
  greetings_text db 'vlad',           0
                 db 'trex',           0            
                 db 'sticky baboon',  0               
                 db 'speedy',         0               
                 db 'riff raff',      0            
                 db 'one',            0
                 db 'mental trip',    0          
                 db 'hex',            0                  
                 db 'extraviolent',   0         
                 db 'civax',          0
                 db 'adept',          0
                 db 'and you',        0
                 db 0                                  
         playing dw 0                    
         tfactor dw 4096                 
            _128 dw 128                                      
                   
  INCLUDE        \assembly\maxium\inc\palette.inc
  INCLUDE        \assembly\maxium\inc\glasspal.inc
  INCLUDE        \assembly\maxium\inc\tile.inc
  INCLUDE        \assembly\maxium\inc\font1.inc
  INCLUDE        \assembly\maxium\inc\maxium.inc
  INCLUDE        \assembly\maxium\inc\music.inc
  INCLUDE        \assembly\maxium\inc\vector.inc
         
  sintable       dw 256 dup (0)
  costable       dw 256 dup (0)
  palette        db 768 dup (0)
  palette2       db 768 dup (0)
  zlist          dw 512 dup (0)       ; middle-z buffer
  plist          dw 512 dup (0)       ; polygon index buffer
  dlist          db 512 dup (0)       ; polygon shading
  vrotate   point3d 512 dup (<0,0,0>) ; points to be rotated
  vrotated  point3d 512 dup (<0,0,0>) ; rotated points
  light     point3d ?
  rlight    point3d ?
  rtemp     point3d ?
  matrix         dw 9   dup (0)
  sprites        dw 4   dup (0)
  stacksegment   dw ?
  stackpointer   dw ?
  keyboard_old   dd ?
  user_routine   dw ?
  xmsaddr        dd ?
  xhandle1       dw ?
  xhandle2       dw ?
  xhandle3       dw ?
  xhandle4       dw ?
  xhandle5       dw ?
  xhandle6       dw ?
  xhandle7       dw ?
  timer_count    dw ?           
  frame_count    dw ?           
  fadeval        dw ?
  dataseg1       dw ?           
  dataseg2       dw ?           
  dataseg3       dw ?           
  dataseg4       dw ?                 
  virtseg        dw ?           
  mfrom          dw ?
  mto            dw ?
  flip           db ?
  bumpx          dw ?
  bumpy          dw ?
  escape         db ?           
  currow         dw ?
  curpos         dw ?
  stage          dw ?
  tmpl           dw ?
  tmpr           dw ?
  tmpdi          dw ?
  l              dw ?
  r              dw ?
  x              dw ?
  y              dw ?           
  z              dw ?
  xa             dw ?
  xo             dw ?
  ya             dw ?
  yo             dw ?
  rx             dw ?
  ry             dw ?
  rz             dw ?
  lx             dw ?
  ly             dw ?
  lz             dw ?
  x1             dw ?
  xx1            dd ?
  xx2            dd ?             
  xx3            dd ?
  cc1            dd ?
  cc2            dd ?
  cc3            dd ?
  dx1            dd ?
  dx2            dd ?
  dx3            dd ?
  dc1            dd ?
  dc2            dd ?
  dc3            dd ?
  mx1            dd ?
  mx2            dd ?
  mc1            dd ?
  mc2            dd ?
  pc1            dd ?
  pc2            dd ?
  cx1            dd ?
  cx2            dd ?
  dcc1           dd ?
  rcx            dw ?
  rcy            dw ?
  rcz            dw ?
  rsx            dw ?
  rsy            dw ?
  rsz            dw ?
  sxsz           dw ?
  czsx           dw ?
  y1             dw ?
  c1             dw ?
  x2             dw ?
  y2             dw ?
  c2             dw ?
  x3             dw ?
  y3             dw ?
  c3             dw ?
  xt             dw ?
  yt             dw ?
  xt1            dw ?
  yt1            dw ?
  a              dw ?
                  
  xmsstruct       label byte
  xmsLength       dd  ?   
  xmsSourceHandle dw  ?   
  xmsSourceOffset dd  ?    
  xmsDestHandle   dw  ?   
  xmsDestOffset   dd  ?
                                  
data ends         
                  
;
                                                
END MAIN
