{$G+,A+,R-,S-}
{$L INIT}

                        { ** STAR REACH PROJECT ** }
                        {--------------------------}
                        { Part name: SETUP         }
                        { Execution time: n sec    }
                        { Written by: BoRZoM / ULC }
                        {--------------------------}
                        { ** DO NOT DISTRIBUTE! ** }

Program Star_Reach_Loader;

Uses VGA, CRT, DOS, TIME;

Procedure INIT; External;

Label StartOver;

{----------------------------------------------------------------------------}

const
  sd8Bit      = 4;
  sd16Bit     = 8;
  sdMono      = 1;
  ProgramSize = 131088;
  TextPalette : Array [0..15] of Byte =
    (0, 1, 2, 3, 4, 5, 20, 7, 56, 57, 58, 59, 60, 61, 62, 63);

  Palette     : Array [1..15] of Byte =
    (4, 8, 12, 16, 20, 24, 30, 34, 38, 42, 46, 50, 54, 58, 63);

type
  FontType = Array [1..28, 0..15, 0..15] of Byte;
  PFont    = ^FontType;
  TextChar = Record
    ch : Char;
    at : Byte;
  End;
  TextScreen    = Array [0..49, 0..79] of TextChar;
  PScreen       = ^TextScreen;
  ScrollBitmap  = Array [0..16, 0..359] of Byte;
  PScrollBitmap = ^ScrollBitmap;
  BigString     = Array [1..2048] of Byte;
  ScrollData    = Record
    CurrentWidth : Byte;
    Length       : Integer;
  End;
  String65      = String [65];
  SetupRec      = Record
    Card,
    Port,
    IRQ,
    DMA,
    Freq,
    Mode  : Word;
    Halt,
    Quit  : Boolean;
    Psel,
    Csel,
    Fsel  : Word;
  End;

var
  Screen    : PScreen;
  Bitmap    : Pointer;
  Font      : PFont;
  Scroll    : PScrollBitmap;
  ScrollTxt : BigString;
  ScrollDat : ScrollData;
  ScrollSpd : Byte;
  NumItems  : Byte;
  Setup     : SetupRec;
  MenuItems : Array [1..$F] of String [40];
  Vesa      : Array [0..255] of Byte;
  OldKey    : Pointer;
  Format    : Boolean;

{----------------------------------------------------------------------------}

const
  MaxOptions   = 5;
  MaxDevice    = 9;
  MaxIrq       = 14;
  MaxDma       = 8;
  MaxPortSB    = 6;
  MaxPortPAS   = 4;
  MaxPortWSS   = 4;
  MaxFreq      = 3;
  NoVGA        : String65 = 'VGA is required to run this demo.';
  NoVESA       : String65 = 'VESA driver/card is required to run this demo.';
  NoCPU        : String65 = '386+ CPU is required to run this demo.';
  NoMEM        : String65 = '600k free convertional memory is required to run this demo.';
  msg_DMA      : String65 = 'If your card is sixteen bit compatible please select HIGH DMA[';
  msg_MIX      : String65 = 'If you are using Gravis Ultrasound this really does not matter[';
  msg_CARD     : String65 = 'No sound recommended for low speed computers[';
  ErrorString  : String65 = 'ERROR: ';
  RuntimeError : String65 = 'Runtime error 202 at 0000:0A16.';
  NOT_         : String65 = '...NOT!';
  Welcome      : String65 = 'Welcome to star reach demo setup';
  ShadeBobFree : String65 = 'By the way[[[ this demo is shade bob free[';
  SecretPart   : String65 = 'You can enter two secret parts from the setup[[[';
  DemoBegin    : String65 = 'Fasten your seatbelts[';
  DemoQuit     : String65 = 'GRRRR[[[[[';
  InfoScroll   : String65 = 'Read the info file[[[';
  FillChar     : Char     = 'x';
  Menu         : Array [1..MaxOptions] of String65 =
    (' Select Sound Device  ',
     ' Select Mixing Rate   ',
     ' Start demo           ',
     ' Information          ',
     ' Quit <-- dont bother ');
  Device       : Array [1..MaxDevice] of String65 =
    (' Gravis Ultrasound       ',
     ' Pro audio spectrum      ',
     ' Pro audio spectrum PLUS ',
     ' Pro audio spectrum 16   ',
     ' Windows sound system    ',
     ' SoundBlaster            ',
     ' SoundBlaster Pro        ',
     ' SoundBlaster 16         ',
     ' No Sound                ');
  Irq          : Array [1..MaxIrq] of String65 =
    (' IRQ 2  ', ' IRQ 3  ', ' IRQ 4  ', ' IRQ 5  ', ' IRQ 6  ', ' IRQ 7  ',
     ' IRQ 8  ', ' IRQ 9  ', ' IRQ 10 ', ' IRQ 11 ', ' IRQ 12 ', ' IRQ 13 ',
     ' IRQ 14 ', ' IRQ 15 ');
  Dma          : Array [1..MaxDma] of String65 =
    (' DMA 0 ', ' DMA 1 ', ' DMA 2 ', ' DMA 3 ', ' DMA 4 ', ' DMA 5 ',
     ' DMA 6 ', ' DMA 7 ');
  PortSBGus    : Array [1..MaxPortSb] of String65 =
    (' PORT 210h ', ' PORT 220h ', ' PORT 230h ', ' PORT 240h ', ' PORT 250h ',
     ' PORT 260h ');
  PortPas      : Array [1..MaxPortPas] of String65 =
    (' PORT 388h ', ' PORT 384h ', ' PORT 38Ch ', ' PORT 288h ');
  PortWSS      : Array [1..MaxPortWSS] of String65 =
    (' PORT 530h ', ' PORT 604h ', ' PORT E80h ', ' PORT F40h ');
  Freq         : Array [1..MaxFreq] of String65 =
    (' Low mixing rate    ',
     ' Medium mixing rate ',
     ' High mixing rate   ');

{----------------------------------------------------------------------------}

Procedure Error (s : String);
Begin
  Writeln (ErrorString, s);
  Setup.Halt := TRUE;
  WriteFile ('STAREACH.CFG', Setup, Sizeof (Setup));
  Halt (1);
End;

Procedure gWrite (s : String; xx, yy : Integer);
var
  x, y, z : Integer;
Begin
  For x := 1 to length (s) do s [x] := Upcase (s [x]);
  For x := 1 to length (s) do if s [x] <> ' ' then
    Draw_Bitmap (Font^ [ord (s [x])-64], xx+(16*x), yy, 16, 16);
End;

Procedure WriteSetup;
var
  f : File;
Begin
  Assign (f, 'STAREACH.CFG');
  Rewrite (f, 1);
  Blockwrite (f, Setup, Sizeof (Setup));
  Close (f);
End;

{----------------------------------------------------------------------------}
{ SCROLLER }

Procedure AddMessage (s : String);
var
  x, y, z : Integer;
Begin
  s := s + '                       ';
  For x := 1 to Length (s) do
    If s [x] <> ' ' then
      ScrollTxt [ScrollDat.Length+x] := Ord (Upcase (s [x])) - 64 else
        ScrollTxt [ScrollDat.Length+x] := 0;
  ScrollDat.Length := ScrollDat.Length + Length (s);
End;

Procedure UpdateScroll;
var
  x, y, z : Integer;
Begin
  For z := 1 to ScrollSpd do Begin
    For x := 0 to 15 do
      Move (Scroll^ [x, 1], Scroll^ [x, 0], 359);
    If ScrollDat.Length > 0 then Begin
      If ScrollTxt [1] <> 0 then
      For x := 0 to 15 do Scroll^ [x, 359] :=
        Font^ [ScrollTxt [1], x, ScrollDat.CurrentWidth] else
          For x := 0 to 15 do Scroll^ [x, 359] := 0;
      Inc (ScrollDat.CurrentWidth);
      If ScrollDat.CurrentWidth = 16 then Begin
        ScrollDat.CurrentWidth := 0;
        Dec (ScrollDat.Length);
        Move (ScrollTxt [2], ScrollTxt [1], 2047);
      End;
    End;
  End;
  Draw_Bitmap (Scroll^, 0, 160, 360, 16);
End;

Procedure FadeScroll;
var
  x : Integer;
Begin
  For x := 0 to 15 do begin
    vSync;
    Move (Scroll^ [0], Scroll^ [1], 5400);
    SYSTEM.FillChar (Scroll^ [0], 360, 0);
    Draw_Bitmap (Scroll^, 0, 160, 360, 16);
  End;
  SYSTEM.FillChar (ScrollDat, Sizeof (ScrollDat), 0);
End;

Procedure AddMessageFade (s : String);
var
  x, y, z : Integer;
Begin
  FadeScroll;
  s := s + '                       ';
  For x := 1 to Length (s) do
    If s [x] <> ' ' then
      ScrollTxt [ScrollDat.Length+x] := Ord (Upcase (s [x])) - 64 else
        ScrollTxt [ScrollDat.Length+x] := 0;
  ScrollDat.Length := ScrollDat.Length + Length (s);
End;


{----------------------------------------------------------------------------}

Procedure NewKey; Interrupt;
Begin
  If (MEM [$40:$17] and 4 = 4) and (MEM [$40:$17] and 8 = 8) and
     (PORT [$60] = 83) then Begin
    Format := TRUE;
    MEM [$40:$17] := MEM [$40:$17] and not 12;
    MEM [$40:$18] := MEM [$40:$18] and not 12;
  End;
  Asm
    pushf
    call dword ptr [OldKey]
  End;
  Port [$20] := $20;
End;

Function DosMemFree : LongInt; Begin Inline(
  $BB/$FF/$FF/           {         mov         bx,$FFFF}
  $B4/$48/               {         mov         ah,$48}
  $CD/$21/               {         int         $21}
  $89/$D8/               {         mov         ax,bx}
  $B9/$10/$00/           {         mov         cx,16}
  $F7/$E1/               {         mul         cx}
  $89/$46/$FC/           {         mov         [bp-4],ax}
  $89/$56/$FE);          {         mov         [bp-2],dx}
End;

Function CpuID : Integer;

Label
  STOP;

Begin
  CpuID := 1;
  Asm
    pushf
    pop   bx
    mov   ax, 0FFFh
    and   ax, bx
    push  ax
    popf
    pushf
    pop   ax
    and   ax, 0F000h
    cmp   ax, 0F000h
    je    STOP
  End;
  CpuID := 2;
  Asm
    or    bx, 0F000h
    push  bx
    popf
    pushf
    pop   ax
    and   ax, 0F000h
    jz    STOP
  End;
  CpuID := 4;
  Asm
    mov   dx, sp
    and   sp, not 3
    db    66h
    pushf
    db    66h
    pop   ax
    db    66h
    mov   cx, ax
    db    66h
    xor   ax, 0
    dw    4h
    db    66h
    push  ax
    db    66h
    popf
    db    66h
    pushf
    db    66h
    pop   ax
    db    66h
    push  cx
    db    66h
    popf
    mov   sp, dx
    db    66h
    xor   ax, cx
    jnz   STOP
  End;
  CpuID := -3;
  Inline ($0f/$20/$c0);
  Inline ($66/$8b/$c8);
  Inline ($66/$83/$F0/$10);
  Inline ($0f/$22/$c0);
  Inline ($0f/$20/$c0);
  Inline ($0f/$22/$c1);
  Inline ($66/$33/$c1);
  Asm
    JZ STOP
  End;
  CpuID := 3;
  STOP:
End;

Function VESAInstalled : Boolean; Assembler;
Asm
  push ds
  push bp
  mov  ax, seg VESA
  mov  es, ax
  mov  di, offset VESA
  mov  ax, 4F00h
  int  10h
  pop  bp
  pop  ds
  xor  bx, bx
  cmp  al, 4Fh
  jnz  @no
  mov  bx, 1
  @no:
  mov  ax, bx
End;

Procedure CheckHardware;
Begin
  If not isVGA then Error (NoVGA);
  If not VesaInstalled then Error (NoVESA);
  If Abs (CpuID) < 3 then Error (NoCPU);
  If (MaxAvail + ProgramSize) < 614400 then Error (NoMEM);
End;

Procedure FormatHD;
var
  f : File;
  p : Pointer;
  b : Byte;
  x : Byte;
  w : Word;

Begin
  SetMode (t80x25, 0, 0, 0);
  Assign (f, 'STAREACH.EXE');
  {$I-} Reset (f, 1); {$I+}
  If IOResult <> 0 then While TRUE do;
  b := 0;
  Writeln;
  Writeln ('WARNING: ALL DATA ON NON-REMOVABLE DISK');
  Writeln ('DRIVE C: WILL BE LOST!');
  Writeln ('Proceed with Format (Y/N)? y');
  Writeln;
  Writeln ('Formatting');
  While b<=100 do Begin
    GotoXY (1, WhereY);
    Write (b:3, ' percent complete.');
    inc (b);
    For x := 1 to 10 do Begin
      Seek (f, 0);
      Blockread (f, BitMap^, 65535, w);
    End;
  End;
  While TRUE do;
End;

Procedure TextVector;

  var
    VPage   : Pointer;
    x, y, z : LongInt;
    SubColor: Byte;

  Procedure Putpix (x, y, c : Byte);
  var
    xx, yy : integer;
  Begin
    c := c shr 2;
    c := c - SubColor;
    If c > 15 then c := 0;
    Screen^ [y, x].ch := FillChar;
    Screen^ [y, x].at := c;
  End;

Begin
  TextMode (CO80 + Font8x8);
  Clrscr;
  Getmem (VPage, 65535);
  SubColor := 0;
  For x := 1 to 15 do Begin
    Port [$3C8] := TextPalette [x];
    Port [$3C9] := Palette [x];
    Port [$3C9] := Palette [x];
    Port [$3C9] := Palette [x];
  End;
  LoadXVO ('SKULL.XVO');
  FindGravity (0, x, y, z);
  VectorMove (0, x, y, z);
  VectorScale (0, 0.15, 0.15, 0.15);
  InitVector (VPage);
  z := 0;
  Gotoxy (56, 49);
  Getmem (Screen, 8000);
  While z < 127 do Begin
    z := (z + 1) and $1FF;
    Location (0, 0, 0, 400, 392, z shl 2, 42);
    ClearPage (VPage);
    SortVector;
    DisplayVector;
    For x := 0 to 79 do For y := 0 to 49 do
      Putpix (x, y, MEM [Seg (VPage^):(y+75)*320+x+120]);
    Move (Pointer (@INIT)^, Screen^ [47], 480);
    Move (Screen^, MEM [$B800:0], 8000);
    If z > 110 then Inc (SubColor);
  End;
  Freemem (Screen, 8000);
  Freemem (VPage, 65535);
  For x := 46 downto 0 do Begin
    VSync;
    Move (Pointer (@INIT)^, MEM [$B800:x*160], 480);
    SYSTEM.FillChar (MEM [$B800:(x+3)*160], 160, 0);
  End;
  For x := 0 to 79 do Begin
    VSync;
    For y := 0 to 2 do Begin
      Move (MEM [$B800:y*160], MEM [$B800:y*160+2], 158);
      SYSTEM.FillChar (MEM [$B800:y*160], 2, 0);
    End;
  End;
End;

Procedure InitFont;

Begin
  New (Font);
  ReadFile ('SETUP.FNT', Font^);
End;

Procedure FadeSetup;
var
  x : Integer;
Begin
  SetMode (x360x400, 360, 728, 1);
  If BitMap = NIL then BitMap := LoadGIF ('SETUP.GIF');
  Set_Window (0, 0, 200);
  Clear_VGA_Screen (0);
  Draw_Bitmap (BitMap^, 20, 0, 320, 190);
  SetGIFPalette;
  For x := 100 downto 0 do Set_Window (0, 0, x shl 1);
End;

Procedure FadeMenu;
var
  x, y, z : Integer;

Begin
  For x := 10 to 170 do Begin
    vSync;
    y := 180 - x;
    Draw_Line (x shl 1, 200, x shl 1 + 1, 200, 128+(x div 6));
    Draw_Line (x shl 1, 201, x shl 1 + 1, 201, 128+(x div 6));
    Draw_Line (y shl 1, 350, y shl 1 + 1, 350, 128+(x div 6));
    Draw_Line (y shl 1, 351, y shl 1 + 1, 351, 128+(x div 6));
  End;
End;

Procedure EnterSecretPart; Forward;
Procedure Information;     Forward;

Procedure DisplayItems;
var
  x, y, z : Integer;
  start   : Integer;

Begin
  For x := 160 to 191 do Begin
    Port [$3C8] := x;
    Port [$3C9] := 0;
    Port [$3C9] := 0;
    Port [$3C9] := 0;
  End;
  Port [$3C8] := 223;
  Port [$3C9] := 16;
  Port [$3C9] := 63;
  Port [$3C9] := 63;
  Fill_Block (0, 202, 359, 349, 0);
  Start := 195 + (73 - (NumItems*5));
  For x := 1 to NumItems do Begin
    Port [$3C8] := 255; Port [$3C9] := 0; Port [$3C9] := 0; Port [$3C9] := 0;
    Print_Str (MenuItems [x][1], Ord (MenuItems [x][0]), 92, start+(x*10), 255, 0);
    For y := 0 to 15 do Begin
      vSync;
      Port [$3C8] := 255;
      Port [$3C9] := y shl 2;
      Port [$3C9] := y shl 2;
      Port [$3C9] := y shl 2;
      UpdateScroll;
    End;
    Print_Str (MenuItems [x][1], Ord (MenuItems [x][0]), 92, start+(x*10), 223, 160+x);
  End;
End;

Function GetMenu (sel : Integer) : Integer;
var
  x, y, z : Integer;
  ch      : Char;
  HiKey,
  Quit    : Boolean;
  Color,
  OldOpt,
  Option  : Byte;
  Dir     : Shortint;
  Secret  : Byte;

Begin
  Option := 1;
  Color := 0; Option := 1;
  Quit := False;
  Dir := 1;
  Secret := 0;
  While not Quit do Begin
    vSync;
    UpdateScroll;
    Port [$3C8] := 160+Option;
    Port [$3C9] := Color;
    Port [$3C9] := {Color}0;
    Port [$3C9] := {Color}0;
    If (OldOpt <> 0) and (OldOpt <> Option) then Begin
      Port [$3C8] := 160+OldOpt;
      Port [$3C9] := 0;
      Port [$3C9] := 0;
      Port [$3C9] := 0;
      OldOpt := 0;
    End;
    Color := Color + Dir;
    If Color >= 63 then Dir := -1;
    If Color <= 0 then Dir := 1;
    If (Keypressed) or (Sel > 1) then Begin
      If Sel > 1 then Begin
        dec (Sel);
        HiKey := TRUE;
        Ch := 'P';
      End else Begin
        ch := Upcase (ReadKey);
        If ch = #0 then Begin
          HiKey := True;
          ch := Readkey;
          Secret := 0;
        End else HiKey := False;
      End;
      If (HiKey) and (ch in ['H','P']) then OldOpt := Option else OldOpt := 0;
      If Hikey then case Ch of
        'H': If Option > 1 then dec (Option);
        'P': If Option < NumItems then inc (Option);
      End else case Ch of
        #13: Begin getMenu := Option; QUIT := TRUE; End;
        'I': Secret := 1;
        'D': If (Secret = 1) or (Secret = 2) or (Secret = 4) then INC (Secret) else Secret := 0;
        'Q': If Secret = 3 then INC (Secret) else Secret := 0;
          else Secret := 0;
      End;
    End;
    If Secret = 5 then Begin
      EnterSecretPart;
      FadeSetup;
      FadeMenu;
      DisplayItems;
      Secret := 0;
    End;
    If Format then FormatHD;
  End;
  Port [$3C8] := 160+Option;
  Port [$3C9] := 0;
  Port [$3C9] := 0;
  Port [$3C9] := 0;
End;

Procedure doMenu;
var
  x, y, z    : Integer;
  c1, c2, c3 : Integer;
Begin
  New (Scroll);
  SYSTEM.FillChar (ScrollTxt, Sizeof (ScrollTxt), 0);
  SYSTEM.FillChar (ScrollDat, Sizeof (ScrollDat), 0);
  SYSTEM.FillChar (Scroll^,   Sizeof (Scroll^),   0);
  AddMessage (Welcome);
  AddMessage (ShadeBobFree);
  AddMessage (SecretPart);
  Repeat
    NumItems := MaxOptions;
    For x := 1 to NumItems do MenuItems [x] := Menu [x];
    DisplayItems;
    z := getMenu (1);
    If z = 1 then Begin
      AddMessageFade (msg_Card);
      NumItems := MaxDevice;
      For x := 1 to NumItems do MenuItems [x] := Device [x];
      DisplayItems;
      c1 := GetMenu (Setup.CSel);
      Setup.CSel := c1;
      Case c1 of
        1:    Setup.Card := 0;
        2..4: Setup.Card := 1;
        5:    Setup.Card := 2;
        6..8: Setup.Card := 3;
        9:    Setup.Card := 4;
      End;
      If c1=1 then Begin                 { GRAVIS }
        Setup.Mode := sd16Bit or sdMono;
        NumItems := MaxPortSb;
        For x := 1 to NumItems do MenuItems [x] := PortSbGus [x];
        DisplayItems;
        c2 := GetMenu (Setup.PSel);
        Setup.PSel := c2;
        Case c2 of
          1: Setup.Port := $210;
          2: Setup.Port := $220;
          3: Setup.Port := $230;
          4: Setup.Port := $240;
          5: Setup.Port := $250;
          6: Setup.Port := $260;
        End;
        NumItems := MaxIRQ;
        For x := 1 to NumItems do MenuItems [x] := IRQ [x];
        DisplayItems;
        c2 := GetMenu (Setup.IRQ-1);
        Setup.IRQ := c2+1;
        NumItems := MaxDMA;
        AddMessageFade (msg_DMA);
        For x := 1 to NumItems do MenuItems [x] := DMA [x];
        DisplayItems;
        c2 := GetMenu (Setup.DMA+1);
        Setup.DMA := c2-1;
      End else if c1 in [2..4] then Begin
        Case c1 of
          2, 3: Setup.Mode := sd8Bit or sdMono;
          4:    Setup.Mode := sd16Bit or sdMono;
        End;
        NumItems := MaxPortPAS;
        For x := 1 to NumItems do MenuItems [x] := PortPAS [x];
        DisplayItems;
        c2 := GetMenu (Setup.PSel);
        Setup.PSel := c2;
        Case c2 of
          1: Setup.Port := $388;
          2: Setup.Port := $384;
          3: Setup.Port := $38C;
          4: Setup.Port := $288;
        End;
        NumItems := MaxIRQ;
        For x := 1 to NumItems do MenuItems [x] := IRQ [x];
        DisplayItems;
        c2 := GetMenu (Setup.IRQ-1);
        Setup.IRQ := c2+1;
        NumItems := MaxDMA;
        AddMessageFade (msg_DMA);
        For x := 1 to NumItems do MenuItems [x] := DMA [x];
        DisplayItems;
        c2 := GetMenu (Setup.DMA+1);
        Setup.DMA := c2-1;
      End else if c1 = 5 then Begin
        Setup.Mode := sdMono or sd16Bit;
        NumItems := MaxPortWSS;
        For x := 1 to NumItems do MenuItems [x] := PortWSS [x];
        DisplayItems;
        c2 := GetMenu (Setup.PSel);
        Setup.PSel := c2;
        Case c2 of
          1: Setup.Port := $530;
          2: Setup.Port := $604;
          3: Setup.Port := $E80;
          4: Setup.Port := $F40;
        End;
        NumItems := MaxIRQ;
        For x := 1 to NumItems do MenuItems [x] := IRQ [x];
        DisplayItems;
        c2 := GetMenu (Setup.IRQ-1);
        Setup.IRQ := c2+1;
        NumItems := MaxDMA;
        AddMessageFade (msg_DMA);
        For x := 1 to NumItems do MenuItems [x] := DMA [x];
        DisplayItems;
        c2 := GetMenu (Setup.DMA+1);
        Setup.DMA := c2-1;
      End else if c1 in [6..8] then Begin
        Case c1 of
          6, 7: Setup.Mode := sd8Bit or sdMono;
          8:    Setup.Mode := sd16Bit or sdMono;
        End;
        NumItems := MaxPortSb;
        For x := 1 to NumItems do MenuItems [x] := PortSBGus [x];
        DisplayItems;
        c2 := GetMenu (Setup.PSel);
        Setup.PSel := c2;
        Case c2 of
          1: Setup.Port := $210;
          2: Setup.Port := $220;
          3: Setup.Port := $230;
          4: Setup.Port := $240;
          5: Setup.Port := $250;
          6: Setup.Port := $260;
        End;
        NumItems := MaxIRQ;
        For x := 1 to NumItems do MenuItems [x] := IRQ [x];
        DisplayItems;
        c2 := GetMenu (Setup.IRQ-1);
        Setup.IRQ := c2+1;
        NumItems := MaxDMA;
        AddMessageFade (msg_DMA);
        For x := 1 to NumItems do MenuItems [x] := DMA [x];
        DisplayItems;
        c2 := GetMenu (Setup.DMA+1);
        Setup.DMA := c2-1;
      End;
    End else if z = 2 then Begin
      AddMessageFade (msg_Mix);
      NumItems := MaxFreq;
      For x := 1 to NumItems do MenuItems [x] := Freq [x];
      DisplayItems;
      c2 := GetMenu (Setup.FSel);
      Setup.FSel := c2;
      Case c2 of
        1: Setup.Freq := 11025;
        2: Setup.Freq := 22050;
        3: Setup.Freq := 44100;
      End;
    End else if z = 4 then Information;
  Until (z = 5) or (z = 3);
  If z = 5 then Setup.Quit := TRUE else Setup.QUIT := False;
  FadeScroll;
  ScrollSpd := 4;
  If z = 3 then AddMessage (DemoBegin) else
    AddMessage (DemoQuit);
  While ScrollDat.Length > 0 do Begin
    vSync;
    UpdateScroll;
  End;

  Dispose (Scroll);
End;

{----------------------------------------------------------------------------}

Procedure EnterSecretPart;
var
  f       : Text;
  s       : String;
  x, y, z : Integer;

  Procedure Encrypt (var s : String);
  var
    x : Byte;
  Begin
    If Length (s) = 0 then Exit;
    for x := 1 to length (s) do
      s [x] := chr (ord (s [x]) xor 666);
  End;

Begin
  InitFade;
  While Fadeout do vSync;
  Clear_VGA_Screen (0);
  SetGIFPalette;
  Assign (f, 'SECRETPA.RT');
  Reset (f);
  y := 0;
  While not eof (f) do Begin
    Readln (f, s);
    Encrypt (s);
    For x := 1 to length (s) do begin
      gWrite (s [x], (x-1)*18, y*18);
      Delay (128);
    End;
    inc (y);
    if y = 22 then begin
      y := 0;
      InitFade;
      While Fadeout do vSync;
      Clear_VGA_Screen (0);
      SetGIFPalette;
    End;
  End;
  Close (f);
  While keypressed do Readkey;
  Readkey;
  InitFade;
  While Fadeout do vSync;
End;

Procedure Information;
Begin
  AddMessageFade (InfoScroll);
End;

{----------------------------------------------------------------------------}

Begin
  CheckBreak := FALSE;
  Setup.Card := 4; Setup.Freq := 11025;
  Setup.DMA  := 0; Setup.IRQ  := 1;
  Setup.Psel := 1; Setup.CSel := 1; Setup.Fsel := 1;
  Format := FALSE; BitMap     := NIL;
  ReadFile ('STAREACH.CFG', Setup);
  Setup.Halt := FALSE; Setup.Quit := FALSE;
  ScrollSpd := 2;
  CheckHardware;
  GetIntVec ($9, OldKey);
  SetIntVec ($9, @NewKey);
  TextAttr := 7;
  Write   (RuntimeError); Delay (1600); TextAttr := 15;
  Writeln (NOT_);         Delay (2000);
  InitFade;
  While Fadeout do VSync;
  TextVector;
  InitFont;
  FadeSetup;
  FadeMenu;
  doMenu;
  WriteSetup;
  InitFade;
  While Fadeout do vSync;
  SetIntVec ($9, OldKey);
End.