{$G+,A+,R-,S-,E-,N-,D-}
{$M 4096, 0, 133120}

                        { ** STAR REACH PROJECT ** }
                        {--------------------------}
                        { Part name: Loader        }
                        { Execution time: n sec    }
                        { Written by: BoRZoM / ULC }
                        {--------------------------}
                        { ** DO NOT DISTRIBUTE! ** }

Uses DOS, CRT, TIME, MFile, MPlayer, Errors, MConfig, DSM, S3M, Midas;

Type
  SetupRec      = Record
    Card,
    Port,
    IRQ,
    DMA,
    Freq,
    Mode  : Word;
    Halt,
    Quit  : Boolean;
    Psel,
    Csel,
    FSel  : Word;

  End;

var
  Module : PmpModule;
  Setup  : SetupRec;
  OldKey : Pointer;
  x      : Integer;

Label EXIT;

Procedure  CursorOff; Assembler;
Asm
  mov  ah, 1
  mov  ch, 20h
  mov  cl, 20h
  int  10h
End;

Function Exist (n : String) : Boolean;
var
  s : SearchRec;
Begin
  FindFirst (n, Anyfile, s);
  Exist := (DOSError = 0);
End;

Procedure SetMusic (Card, Port, IRQ, DMA, Freq, Mode : Word);
Begin
  MidasSetDefaults;
  MidasSDNumber := Card;
  MidasSDPort := Port;
  MidasSDIRQ := IRQ;
  MidasSDDMA := DMA;
  MidasMixRate := Freq;
  MidasOutputMode := Mode;
End;

Procedure PlayMusic (Name : PChar);
Begin
  If MidasSDNumber <> 4 then Begin
    MidasInit;
    DSMSetMasterVolume (63);
    Module := MidasLoadModule (Name, @mpS3M, NIL);
    MidasPlayModule (Module, 0);
  End;
End;

Procedure StopMusic;
Begin
  If MidasSDNumber <> 4 then Begin
    MidasFreeModule (Module);
    MidasClose;
  End;
End;

Procedure NewKey; Interrupt; Assembler;
Asm
  in   al, 60h
  in   al, 61h
  mov  ah, al
  or   al, 80h
  out  61h, al
  mov  al, ah
  out  61h, al
{ mov  ax, 40h
  mov  es, ax
  xor  ax, ax
  mov  es:[17h], al
  mov  es:[18h], al
  mov  al, es:[1Ch]
  mov  es:[1Ah], al }
  mov  al, 20h
  out  20h, al
End;

Procedure HookInterrupts;
Begin
  GetIntVec ($9, OldKey);
  SetIntVec ($9, @NewKey);
End;

Procedure RestoreInterrupts;
Begin
  SetIntVec ($9, OldKey);
End;

Begin
  ReadFile ('STAREACH.CFG', Setup);
  If Setup.HALT then Halt;
  If Setup.QUIT then Begin
    asm
      mov ax, 3
      int 10h
    end;
    Writeln ('You have not been watching StarReach - ULC Production in 1995');
    Writeln ('First presented at Movement ''95                              ');
    Halt;
  End;
  CursorOff;
  With Setup do SetMusic (Card, Port, IRQ, DMA, Freq, Mode);
  PlayMusic ('STARMAIN.S3M');

  HookInterrupts;
  Exec ('ULC.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('WATER.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('TUNNEL.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('BUBBLES.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('DEMOP1.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('TEXTURE.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('VIEWPIC.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('VECPART.EXE','');
  If PORT [$60]=1 then goto EXIT;
  For x := 63 downto 0 do Begin
    DSMSetMasterVolume (63);
    Delay (32);
  End;
  StopMusic;
  PlayMusic ('STAREND.S3M');
  Exec ('VIEWPIC2.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('ENDPART.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('VIEWPIC3.EXE','');
  If PORT [$60]=1 then goto EXIT;
  Exec ('VSCROLL.EXE','');
  EXIT:
  RestoreInterrupts;
  StopMusic;
  For x := 63 downto 0 do Begin
    DSMSetMasterVolume (63);
    Delay (32);
  End;
  asm
    mov ax, 3
    int 10h
  end;
  Writeln ('You have been watching StarReach - ULC Production in 1995');
  Writeln ('First presented at Movement ''95                          ');
End.