{$G+,A+,R-,S-,O-,Q-}
unit P_GREETS;

Interface

procedure Greetings;

Implementation

uses CRT, DOS, SOUND, vga, vga3d, vgagif, timer, fade;

{$I CARROT.INC}

type
  PFrames = ^TFrames;
  TFrames = record
    ax, ay, az,
    tx, ty, tz : integer;
  End;

var
  v       : Vector;
  x, y, z : Integer;
  map, p  : Pointer;
  Frame   : Integer;
  sintable: array [0..511] of Shortint;
  Frames  : array [0..511] of PFrames;
  NumFrame: Integer;

procedure _Sync; far;
begin
  inc (Frame);
end;

procedure AddFrame (ax, ay, az, tx, ty, tz : Integer);
Begin
  new (Frames [NumFrame]);
  Frames [NumFrame]^.ax := ax;
  Frames [NumFrame]^.ay := ay;
  Frames [NumFrame]^.az := az;
  Frames [NumFrame]^.tx := tx;
  Frames [NumFrame]^.ty := ty;
  Frames [NumFrame]^.tz := tz;
  Inc (NumFrame);
End;

procedure MakeFrames;
begin
  x:=100;
  For z := 0 to 32 do Begin
    x:=(x+8)and 511;
    AddFrame (0, z*8-256, 512-(32-z)*8,
              (x+20)and 511, 0, 0);
  End;
  x:=120;
  For z := 0 to 64 do Begin
    x:=(x+8)and 511;
    AddFrame (0, 0, 512,
                   511-(sintable[x]+63)and 511, 0, 0);
  End;
  x := 511-(sintable[x]+63)and 511;
  For z := 0 to 64 do Begin
    x:=(x+16)and 511;
    AddFrame (0, 0, 512+z*64, x, 0, 0);
  End;
end;

procedure Greet (n : String; s: Integer);
var
 shit2:pointer;
begin
  mark(shit2);
  v.Init (nil,n);
  v.gravity(x,y,z);
  v.move(x,y,z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 512);
  v.SetMaterial (sEnvironment, 128, Map);
  v.SetAngle (0);
  Frame := 0;
  While Frame < NumFrame do Begin
    If Frame < 64 then FadePalette (Frame) else
     If Frame > NumFrame-64 then FadePalette (64-(Frame-(NumFrame-64))) else
       FadePalette (64);

    ClearPage (p);
    v.SetLocation (Frames [Frame]^.ax-s, Frames [Frame]^.ay, Frames [Frame]^.az);
    v.SetRotation (Frames [Frame]^.tx, Frames [Frame]^.ty, Frames [Frame]^.tz);
    v.Render;
    v.Project;
    Viewpage (p);
  End;
  v.Done;
  release(shit2);
End;

Procedure Greetings;
Begin
  SetMode (g320x200, 320, 200, 1);
  For x := 0 to 512 do begin
    sintable [x] := round (cos(x*2*pi/512)*63)+63;
    if (sintable[x]<0)or(sintable[x]>511)then halt;
  end;
  NumFrame := 0;
  MakeFrames;
  maxx := 318; maxy := 198;
  map := LoadGIF (f_Phong4);
  InitPalette (GIFPalette);
  GIFPalette [2] := 32;
  Getmem (p, 65535);
  tmrSyncSCR (sync, @_sync, NIL, NIL);

  Greet (f_Greet1, 0);
  Greet (f_Greet2, 0);
  Greet (f_Greet3, 20);
  Greet (f_Greet4, 10);
  Greet (f_Greet5, 25);
  Greet (f_Greet6, 0);
  Greet (f_Greet7, 0);
  Greet (f_Greet8, 0);

  tmrStopSCRsync;
End;

End.