Procedure Getmem (var p; size:word);
begin
  if maxavail < size then begin
    stopmusic;
    vga.setmode(t80x25,0,0,0);
    writeln ('error: not enough memory');
    halt;
  end;
  system.getmem (pointer(p),size);
end;

function checkdrive (s:string):boolean;
var
 sr:searchrec;
begin
 findfirst(s+'\*.*',anyfile,sr);
 checkdrive:=doserror=0;
end;

Procedure PanScreen (i : Integer);                 { commented for morphium }
var
  j : Integer;
  av,bv:byte;
Begin
  if ratio then av := 3 else av := 4;
  if ratio then bv := 7 else bv := $0F;
  if i < 0 then exit;
  Inline ($FA);                                                      { CLI }
  While (Port [$3DA] and 8) = 8 do;                      { wait for screen }
  j := (i shr av)*80;                           { calculate screen position }
  Port [$3D4] := $C; Port [$3D5] := hi (j);          { set screen position }
  Port [$3D4] := $D; Port [$3D5] := lo (j);           { the same, low word }
  While (Port [$3DA] and 8) <> 8 do;                    { wait for retrace }
  Port [$3D4] := 8;                              { pan smoothly the screen }
  Port [$3D5] := (Port [$3D5] and $E0) or (i and bv);    { position mod 16 }
  Inline ($FB);                                                      { STI }
End;

Function fill (s : string; b : byte) : string;
var
  x : Integer;
begin
  fill := s;
  if (length(s)>=b)then exit;
  for x := 0 to b-length(s) do s := s+' ';
  fill := s;
end;

Procedure FastWrite (s : String; _x, _y, color : Integer; p : Pointer);
var
  x, y : Integer;
  ofs  : Word;
Begin
  ofs := _y*160+_x*2+SYSTEM.ofs(p^);
  For x := 0 to length (s)-1 do
    memw [seg(p^):ofs+x shl 1] := color shl 8 + ord(s[x+1]);
End;

Function S3MName (s : string) : string;
var
  f: file;
  st: string;
begin
  assign (f,s);
  reset (f,1);
  blockread (f, st[1], 29);
  close(f);
  st[0]:=#29;
  st[0]:=chr (pos (#$1A, st)-1);
  S3MName := st;
end;

Procedure GIFRes (s : String; var x, y : Word; var bit:byte);
var
  f    : File;
Begin
  Assign (f, s);
  Reset (f, 1);
  Seek (f, 6);
  Blockread (f, x, 2);
  Blockread (f, y, 2);
  Blockread (f, bit, 1);
  close (f);
  bit := (bit and 7)+1;
end;

function trail (s:string):string;
begin
  while s[length(s)]=' ' do delete(s,length(s),1);
  trail := s;
end;
