{$G+,A+,F-,R-,S-,O-,X+,V+}

                        { TATOO ANSI/GIF VIEWER }
                        { CODE: BORZOM          }

uses midas, mplayer, sdevice, s3m,
     vga, vgafx, vgagif, vgavesa, ansi, supervga,
     crt, dos;

type
  SAUCERec = RECORD
    ID       : Array [1..5] of Char;
    Version  : Array [1..2] of Char;
    Title    : Array [1..35] of Char;
    Author   : Array [1..20] of Char;
    Group    : Array [1..20] of Char;
    Date     : Array [1..8] of Char;
    FileSize : Longint;
    DataType : Byte;
    FileType : Byte;
    TInfo1   : Word;
    TInfo2   : Word;
    TInfo3   : Word;
    TInfo4   : Word;
    Comments : Byte;
    Flags    : Byte;
    Filler   : Array [1..22] of Char;
  End;
  OneFile = Record
    Name   : String [12];
    Desc   : String [29];
    Author : String [19];
    Color  : Byte;
  End;
  OneType = Record
    Ext : String [3];
    Col : Byte;
  End;

  PDirectory = ^TDirectory;
  TDirectory = Array [0..1022] of OneFile;

const
  SaverTime = 60; { seconds }
  NumTypes  = 8;
  TheTypes  : Array [1..NumTypes] of OneType =
    ((ext:'NFO'; col:08),
     (ext:'MEM'; col:08),
     (ext:'SIT'; col:08),
     (ext:'DIZ'; col:08),
     (ext:'ASC'; col:08),
     (ext:'ANS'; col:08),
     (ext:'GIF'; col:07),
     (ext:'S3M'; col:15));

var
  module    : pmpModule;
  Playing   : Byte;
  info      : PDirectory;
  infosize  : Word;
  axxs,
  axx       : Real;       { floating point sux }
  ys,
  x, y, z   : Integer;
  key       : Char;
  i         : Pointer;
  quit      : Boolean;
  Line,
  Selection : Integer;
  min       : Integer;
  Save      : Pointer;
  pal       : Array [0..767] of Byte;
  icolor    : Boolean;
  ratio     : boolean;
  volume    : Integer;
  amode     : Boolean;
  cmode     : Byte;
  keycode   : byte;
  old9      : Pointer;
  olddir    : String;
  svmodes   : array [1..3] of word;
  vesabpl   : word;
  ps        : string;
  ch        : char;
  vesabnk   : word;
  nosound   : boolean;

{$I SPLASH.INC}
{$I MISC.INC}
{$L CREDITS.OBJ}
{$L IMAGE.OBJ}
{$L HELP.OBJ}

Procedure Credits; External;
Procedure Image; External;
Procedure Help;  External;

Procedure ScreenSaver;
type
  star = record
    x, y, z : Integer;
  End;

var
  x, y, z,
  xx, yy   : Integer;
  Charset  : Array [1..8192] of Byte;
  Buffer   : Array [1..4096] of Byte;
  stars    : Array [1..128] of Star;

Begin
  Move (MEM [$B800:$0000], Save^, 4000);
  td_Zoom;
  randomize;
  GetFont (Charset);
  Fillchar (Buffer, 4096, 0);
  FastWrite ('.Screen Saver  Press any key.', 25, 0, Cyan, @Buffer);
  SetCharMap (1, 2);
  For X := 1 to 128 do Begin
    Stars [X].X := 320 - Random (640);
    Stars [X].Y := 200 - Random (400);
    Stars [X].Z := -Random (320);
  End;
  SetRGB (1, 42, 42, 42);
  while not keypressed do Begin
    Fill386 (Charset[2040], 6152);
    Fill386 (Buffer [321],  3776);
    tgCount := 128;
    For X := 1 to 128 do Begin
      Stars [X].Z := Stars [X].Z + 3;
      If Stars [X].Z >= 250 then Begin
        Stars [X].X := Random (640)-320;
        Stars [X].Y := Random (400)-200;
        Stars [X].Z := -100;
      End;
      XX := 320 + Stars [X].X shl 7 div (320 - Stars [X].Z);
      YY := 200 - Stars [X].Y shl 7 div (320 - Stars [X].Z);
      If (yy > 32)and(yy<400)and
         (xx > 0) and(xx<640)then tgPixel (xx, yy, Buffer, Charset);
    End;
    WaitSync;
    SetCharSet (Charset [1], Charset [4097], 1, 2);
    Copy386 (Buffer, MEM [$B800:$0000], 4000);
  End;
  while keypressed do CRT.Readkey;
  Fill386 (MEM [$B800:$0000], 4000);
  SetCharMap (0, 0);
  y := ys;
  axx := axxs;
  PanScreen (y);
  SetRGB (1, 0, 0, 32);
  move (Save^, mem [$B800:$0000], 4000);
  For x := 1 to 64 do Begin
    y := round (y-axx);
    axx := axx - 0.4;
    PanScreen (y);
  End;
End;

Function Readkey : Char;
var
  h,m,s,shit : Word;
  time1,
  time2      : Longint;
  s1,s2      : String;
  count      : Integer;

Begin
  checkbreak := false;
  GetTime (h, m, s, shit);
  Time1 := h*3600+m*60+s;
  count := 0;
  While not keypressed do begin
    inc (count);
    if count > 256 then begin
      count := 0;
      GetTime (h, m, s, shit);
      Time2 := h*3600+m*60+s;
      If Time2-Time1 > SaverTime then Begin
        ScreenSaver;
        GetTime (h, m, s, shit);
        Time1 := h*3600+m*60+s;
      End;
      str(h:2,s1); if s1[1]=' ' then s1[1]:='0';
      str(m:2,s2); if s2[1]=' ' then s2[1]:='0';
      s1:=s1+':'+s2;
      fastwrite(s1,74,24,$87,ptr($b800,0000));
    end;
  End;
  Readkey := CRT.Readkey;
End;

Procedure QuickSort (L, R : integer);

Var
  I, J : Integer;
  X, Y : OneFile;
  Col  : Byte;

Begin
  I := l;
  J := r;
  X := info^[(L + R) div 2];
  Repeat
    While info^ [I].name < X.name do Inc (I);
    While X.name < info^ [J].name do Dec (J);
    If I <= J then Begin
      Y := info^ [I];
      info^ [I] := info^ [J];
      info^ [J] := y;
      Inc (I);
      Dec (J);
    End;
  Until I > J;
  if L < J Then QuickSort (L, J);
  if I < R Then QuickSort (I, R);
End;

Procedure ReadDirectory;
var
  s    : Searchrec;
  x, y : Integer;
  f    : file;
  sauce: SauceRec;
  sto,
  st   : String;
  vs   : boolean;
  c    : byte;

function saucename (s:String) : string;
begin
  vs := false;
  assign (f, s);
  {$I-}reset (f, 1);
  if ioresult<>0 then begin
    saucename:='';
    fillchar(sauce,sizeof(sauce),0);
    exit;
  end;
  seek (f, filesize(f)-128);
  blockread (f, sauce, 128);
  close (f);
  move (sauce.id, st[1], 5);
  st[0]:=#5;
  if st='SAUCE' then begin
    move (sauce.title, st[1], 35);
    st[0]:=#29;
    vs := true;
    saucename := st;
  end else saucename := '';
end;

function SauceAuthor : string;
begin
  if vs then begin
    move (sauce.author, st[1], 20);
    st[0]:=#19;
    sauceauthor := st;
  end else sauceauthor := '';
end;
label baah;
Begin
  infosize := 0;
  for x := 1 to NumTypes do Begin
    findfirst ('*.'+TheTypes[x].Ext, anyfile, s);
    while doserror = 0 do begin
      info^ [infosize].Name := fill (s.name, 12);
      info^ [infosize].Color := TheTypes[x].Col;
      if x=numtypes then begin
        info^[infosize].Desc := fill (S3MName (s.name),29);
        info^[infosize].Author := fill ('', 19);
      end else begin
        info^[infosize].Desc := fill (sauceName (s.name), 29);
        info^[infosize].Author := fill (sauceAuthor, 19);
      end;
      inc (infosize);
      if infosize>1022 then goto baah;
      findnext (s);
    end;
  end;
  quicksort(0,infosize-1);
  y:=infosize;
  findfirst ('*.*', anyfile, s);
  while doserror =0 do begin
    if (s.name[1]<>'.')and(s.attr and directory<>0) then begin
      info^[infosize].name := fill (s.name, 12);
      info^[infosize].desc := fill ('sub-directory', 29);
      info^[infosize].author := fill ('', 19);
      info^[infosize].color := cyan;
      inc (infosize);
      if infosize>1022 then goto baah;
    end;
    findnext (s);
  end;
  if infosize-y>1 then quicksort(y,infosize-1);
  info^[infosize].name := fill ('..', 12);
  info^[infosize].desc := fill ('parent-directory', 29);
  info^[infosize].author := fill ('', 19);
  info^[infosize].color := cyan;
  inc (infosize);
  getdir (0, sto);
  for c := ord('A') to ord('Z') do begin
    st := chr(c)+':';
    {$I-} chdir (st); {$I+}
    if ioresult = 0 then begin
      info^[infosize].name := fill (st, 12);
      info^[infosize].desc := fill ('drive', 29);
      info^[infosize].author := fill ('', 19);
      info^[infosize].color := cyan;
      inc (infosize);
      if infosize>1022 then goto baah;
    end;
  end;
  baah:
  chdir (sto);
  if InfoSize < 8 then min := InfoSize-1 else min := 7;
End;

Procedure DrawDirectory;
var
  x, y : Integer;
  bg   : Byte;

Begin
  For x := 0 to min do Begin
    If Selection = x then bg := $4F else bg := info^[x+Line].Color;
    FastWrite (info^[x+Line].Name,   3,  14+x, bg, ptr ($B800,0));
    FastWrite (info^[x+Line].Desc,   18, 14+x, 1, ptr ($B800,0));
    FastWrite (info^[x+Line].Author, 55, 14+x, 1, ptr ($B800,0));
  End;
End;

Procedure EraseDirectory;
var
  x, y : Integer;
  bg   : Byte;

Begin
  For x := 0 to 7 do Begin
    FastWrite (fill('',11),  3, 14+x, 1, ptr ($B800,0));
    FastWrite (fill('',28), 18, 14+x, 1, ptr ($B800,0));
    FastWrite (fill('',18), 55, 14+x, 1, ptr ($B800,0));
  End;
End;

Procedure HelpScreen;
Begin
  move (MEM [$B800:$0000], Save^, 4000);
  For z := 1 to 20 do Begin
    For x := 0 to 24 do
      Copy386 (MEM [seg(@Help^):ofs(@Help^)+x*160], MEM [$B800:x*160+(160-(z*8))], z*8);
    WaitSync;
  End;
  CRT.Readkey;
  While keypressed do CRT.Readkey;
  For z := 1 to 20 do Begin
    For x := 0 to 24 do
      Copy386 (MEM [seg(Save^):ofs(Save^)+x*160], MEM [$B800:x*160+(160-(z*8))], z*8);
    WaitSync;
  End;
End;

Procedure DrawLine (var Buf; Line, Width : Integer); Far;
var
  x, y : Integer;
  l    : Longint;
  b    : word;

Begin
  l:=line*vesabpl;
  For x := 0 to Width-1 do begin
    b := l shr 16;
    if b <> vesabnk then begin
      setbank(l shr 16);
      vesabnk := b;
    end;
    mem[$A000:word(l)]:=mem[seg(buf):ofs(buf)+x];
    inc (l);
  end;
End;

Procedure New9Int; Interrupt; Assembler;
Asm
  in   al, 60h
  mov  KeyCode, al
  in   al, 61h
  mov  ah, al
  or   al, 80h
  out  61h, al
  mov  al, ah
  out  61h, al
  mov  ax, 40h
  mov  es, ax
  xor  ax, ax
  mov  es:[17h], al
  mov  es:[18h], al
  mov  al, es:[1Ch]
  mov  es:[1Ah], al
  mov  al, 20h
  out  20h, al
End;

Procedure ViewFile (s : String);
var
  xr,
  yr   : Word;
  m    : Word;
  al   : Integer;
  q    : Boolean;
  ml   : Integer;
  Posi,
  Vel  : Integer;
  k    : Byte;
  e    : boolean;
  bit  : byte;

label shitthere,shithere,autoshit;

Begin
  Move (MEM [$B800:$0000], Save^, 4000);
  If pos ('.GIF', s) > 0 then Begin { GIF }
    GifRes (s, xr, yr, bit);
    if bit<>8 then goto shitthere;
    if (xr<=320)and(yr<=200) then m := g320x200 else
      if (xr<=256)and(yr<=256) then m := g256x256 else
        if (xr<=640)and(yr<=480) then m := 100 else
          if (xr<=800)and(yr<=600) then m := 101 else
            if (xr<=1024)and(yr<=768) then m := 102;
    If m >= 100 then
      case m of
        100: VesaBPL := 640;
        101: VesaBPL := 800;
        102: VesaBPL := 1024;
      End;
    e := (chip = __ega);
    if not e then
    case m of
      100: if mm < (640*480) div 1024 then e := true;
      101: if mm < (800*600) div 1024 then e := true;
      102: if mm < (1024*768) div 1024 then e := true;
    end;
    if (not e)and(m>99) then e := (svmodes[m-99]=0);
    if e then begin
      shitthere:
      textattr := 7;
      clrscr;
      gotoxy (16, 12);
      write (' gif resolution not supported by graphics card ');
      delay (1024);
      goto shithere;
    end;
    if m < 100 then begin
      vga.SetMode (m, 0, 0, 0);
      VesaBPL := MaxX;
    end else setmode (svmodes[m-99]);
    for xr := 0 to (mm div 64)-1 do begin
      setbank(xr);
      fillchar(mem[$A000:0],65535,0);
    end;
    setbank (0);
    vesabnk := 0;
    UserProc := DrawLine;
    ReadGIF (s);
    CRT.Readkey;
    While Keypressed do CRT.Readkey;
    InitFade;
    While Fadeout do Begin
      Fadeout;
      WaitSync;
    End;
    vga.setmode (tg80x25, 0, 0, 0);
    icecolor (false);
    setcursor ($ff,$ff);
  End else if pos ('.S3M', s) > 0 then begin
    if not nosound then Begin { MUSIC }
      s:=s+#0;
       For xr := Volume downto 0 do Begin
         SoundDevice(midasSD^).SetMasterVolume (xr);
         WaitSync;
       End;
       if playing=1 then midasStopModule(module);
      playing:=1;
      midasFreeModule(module);
      module := midasLoadModule (@s[1], @mpS3M, NIL);
      midasPlayModule(module, 0);
      SoundDevice(midasSD^).SetMasterVolume (volume);
    end;
  End else Begin  { ANSI / TEXT }
    if ratio then
      vga.SetMode (tg80x50, 0, 0, 0) else
        vga.SetMode (tg80x25, 0, 0, 0);
    setcursor ($ff, $ff);
    if icolor then icecolor(false);
    if cmode=1 then begin
      getpalette (pal);
      for xr:=0 to 255 do begin
        yr := (pal[xr*3]+pal[xr*3+1]+pal[xr*3+2]) div 3;
        pal[xr*3]:=yr;
        pal[xr*3+1]:=yr;
        pal[xr*3+2]:=yr;
      end;
      setpalette(pal);
    end else if cmode=2 then
      for xr:=1 to 15 do setrgb(textpalette[xr],42,42,42);
    Getmem (i, 32767);
    LoadAnsi (s, i);
    move (i^, mem [$b800:0], 32000);
    if ratio then
      ml := ansi.lines*8-400
        else ml := ansi.lines*16-400;
    al := 0;
    q := FALSE;
    GetIntVec (9, Old9);
    SetIntVec (9, @New9Int);
    if not amode then begin
      Posi := 0;
      Vel := 0;
      autoshit:
      PanScreen (Posi);
      keycode := 0;
      Repeat
        k := keycode;
        Case k of
          72: Dec (Vel, 8);
          80: Inc (Vel, 8);
        End;
        If (Vel > 0) then Dec (Vel, 5) else if (Vel < 0) then Inc (Vel, 5);
        Inc (Posi, Vel div 8);
        If Posi < 0 then Posi := 0
          else If Posi > ml then Posi := ml;
        PanScreen (Posi);
      Until (k=1) or (k=28);
    End else Begin
      vel := 3;
      posi := 0;
      keycode := 0;
      repeat
       posi := posi + vel;
       if (posi>ml)or(posi<0)then vel := -vel;
       if posi>ml then posi:=ml;
       if posi<0 then posi:=0;
       panscreen (posi);
       k := keycode;
      until (k=1)or(k=28)or(k=72)or(k=80);
      if (k=72)or(k=80)then begin
        vel:=64;
        goto autoshit;
      end;
    End;
    SetIntVec (9, Old9);
    InitFade;
    While Fadeout do Begin
      Fadeout;
      WaitSync;
    End;
    freemem (i, 32767);
    vga.setmode (tg80x25, 0, 0, 0);
    icecolor (false);
    setcursor ($ff,$ff);
  End;
  shithere:
  For z := 1 to 20 do Begin
    For x := 0 to 24 do
      Copy386 (MEM [seg(Save^):ofs(Save^)+x*160+(160-(z*8))], MEM [$B800:x*160], z*8);
    WaitSync;
  End;
End;

Procedure DrawStatus;
var
  st : String;
Begin
  str (volume*100 div 64:3, st);
  FastWrite (st, 9, 24, $80, ptr ($B800,$0000));
  if ratio then st := '50' else st := '25';
  FastWrite (st, 23, 24, $80, ptr ($B800,$0000));
  case cmode of
    0: st := 'color';
    1: st := 'grey ';
    2: st := 'ascii';
  end;
  FastWrite (st, 34, 24, $80, ptr ($B800,$0000));
  if icolor then
    fastwrite ('icecolor', 42, 24, $8F, ptr ($B800,$0000))
      else fastwrite ('icecolor', 42, 24, $80, ptr ($B800,$0000));
  if amode then
    fastwrite ('auto', 53, 24, $8F, ptr ($B800,$0000))
      else fastwrite ('auto', 53, 24, $80, ptr ($B800,$0000));
End;

Procedure DrawCredits;
Begin
  Move (Pointer (@Credits^), MEM [$B800:$0000], 4000);
  GotoXY (1, 19);
End;

label argh;

Begin
  checkbreak := false;
  icolor := false;
  nosound := false;
  ratio := false;
  amode := false;
  cmode := 0;
  volume := 64;
  GetDir (0, olddir);
  fillchar (mem [$B800:$1000], 4000, 0);
  y := 0;
  axx := 0;
  For x := 1 to 64 do begin
    y := round (y+axx);
    axx := axx + 0.4;
    PanScreen (y);
  End;
  ys := y;
  axxs := axx;
  fillchar (mem[$b800:0],4000,0);
  fillchar(dotest,sizeof(dotest),ord(true));
  dotest[__xbe]:=false;
  dotest[__xga]:=false;
  dotest[__HMC]:=false;
  dotest[__UMC]:=false;
  dotest[__p2000]:=false;
  dotest[__poach]:=false;
  dotest[__yamaha]:=false;
  findvideo;
  selectvideo(vids);
  if (chip=__none)or
     (chip=__ega)or
     (chip=__vga)then begin
    vga.setmode (tg80x25, 0, 0, 0);
    writeln ('SVGA card not found - high resolution gifs will no be shown.');
    delay (1024);
  end;
  fillchar(svmodes,sizeof(svmodes),0);
  for x:= 1 to 50 do begin
    if (modetbl[x].memmode=_p8)and(modetbl[x].xres=640)and(modetbl[x].yres=480) then svmodes[1]:=modetbl[x].md;
    if (modetbl[x].memmode=_p8)and(modetbl[x].xres=800)and(modetbl[x].yres=600) then svmodes[2]:=modetbl[x].md;
    if (modetbl[x].memmode=_p8)and(modetbl[x].xres=1024)and(modetbl[x].yres=768) then svmodes[3]:=modetbl[x].md;
  end;
  vga.setmode (tg80x25, 0, 0, 0);
  icecolor (false);
  setcursor ($ff,$ff);
  PanScreen (y);
  Line := 0;
  Selection := 0;
  Getmem (info, sizeof (OneFile)*1023);
  Getmem (save, 4096);
  move (pointer (@image)^, mem [$B800:$0000], 4000);
  ReadDirectory;
  DrawDirectory;
  For x := 1 to 64 do Begin
    y := round (y-axx);
    axx := axx - 0.4;
    PanScreen (y);
  End;
  Quit := False;
  PlayMusic;
  Playing := 1;
{--------------------------------MAIN SHIT-----------------------------------}
  While not QUIT do Begin
    ch := readkey;
    case upcase(ch) of
 'A'..'Z',
 '0'..'9': for x:=0 to infosize-1 do if info^[x].name[1]=upcase(ch) then begin
             if x < 8 then begin
               selection:=x;
               line:=0;
             end else begin
               selection:=7;
               line:=x-7;
             end;
             goto argh;
           end;
      #27: Quit := True;
      #13: if info^[selection+line].color <> cyan then
          ViewFile (info^ [Selection+Line].Name) else begin
          if checkdrive (trail (info^[selection+line].Name)) then begin
            {$I-} chdir (trail (info^[selection+line].Name)) {$I+};
            if ioresult=0 then begin
              selection := 0;
              line := 0;
              ReadDirectory;
              EraseDirectory;
            end;
          end;
        End;
      #0: case readkey of
            #72: If Selection > 0 then dec (Selection) else
                   If Line > 0 then dec (Line);
            #80: If Selection < min then Inc (Selection) else
                   If Selection+Line+1 < InfoSize then Inc (Line);
            #59: HelpScreen;
            #60: if not nosound then Begin
                   Playing := Playing xor 1;
                   If Playing=0 then midasStopModule(module) else
                     midasPlayModule (module, 0);
                 End;
            #61: if icolor then icolor:=false else icolor:=true;
            #62: cmode := (cmode+1)mod 3;
            #63: If ratio then ratio:=false else ratio:=true;
            #64: if amode then amode:=false else amode:=true;
            #66: ScreenSaver;
            #67: if not nosound then If Volume > 0 then Begin Dec (Volume);
                   sounddevice(midasSD^).setmastervolume (volume); End;
            #68: if not nosound then If Volume < 64 then Begin Inc (Volume);
                   sounddevice(midasSD^).setmastervolume (volume); End;
          End;
    End;
    argh:
    DrawDirectory;
    DrawStatus;
  End;
{----------------------------------------------------------------------------}
  y := 0; axx := 0;
  For x := 1 to 64 do begin
    y := round (y+axx);
    axx := axx + 0.4;
    PanScreen (y);
  End;
  vga.SetMode (t80x25, 0, 0, 0);
  GetPalette (pal);
  BlankPalette;
  DrawCredits;
  InitFadeTo (pal);
  While FadeTo do WaitSync;
  {$I-} ChDir (olddir); {$I+}
  StopMusic;
End.