{$G+,A+,R-,S-}
Uses CRT, DOS;

                        { ** STAR REACH PROJECT ** }
                        {--------------------------}
                        { Part name: INFO INTRO    }
                        { Execution time: n sec    }
                        { Written by: BoRZoM / ULC }
                        {--------------------------}
                        { ** DO NOT DISTRIBUTE! ** }


Type
  ScreenType = Array [1..25*8, 1..80, 0..1] of Byte;
  String80   = String [80];

var
  Screen     : ScreenType absolute $B800:$0000;
  i, k, vel,
  Lines, Pos,
  Time       : Integer;
  s          : String;
  p          : Pointer;
  tText      : Array [1..2048] of ^String80;
  f          : Text;
  KeyCode    : Byte;
  OldKey     : Pointer;
  Bool       : Byte;
  Rpal,
  Rpal2      : Array [0..399] of Byte;
  x,y,z      : integer;

Procedure New9Int; Interrupt; Assembler;
Asm
  in   al, 60h
  mov  KeyCode, al
  in   al, 61h
  mov  ah, al
  or   al, 80h
  out  61h, al
  mov  al, ah
  out  61h, al
  mov  ax, 40h
  mov  es, ax
  xor  ax, ax
  mov  es:[17h], al
  mov  es:[18h], al
  mov  al, es:[1Ch]
  mov  es:[1Ah], al
  mov  al, 20h
  out  20h, al
End;

Procedure InitKeyboard;
Begin
  GetIntVec (9, OldKey);
  SetIntVec (9, @New9Int);
End;

Procedure RestoreKeyboard;
Begin
  SetIntVec (9, OldKey);
End;

Procedure PanScreen (i : Integer);                 { commented for morphium }
var
  j : Integer;

Begin
  While (Port [$3DA] and 8) = 8 do;                      { wait for screen }
  j := (i shr 4)*80;                           { calculate screen position }
  Inline ($FA);                                                      { CLI }
  Port [$3D4] := $C; Port [$3D5] := hi (j);          { set screen position }
  Port [$3D4] := $D; Port [$3D5] := lo (j);           { the same, low word }
  Inline ($FB);                                                      { STI }
  While (Port [$3DA] and 8) <> 8 do;                    { wait for retrace }
  Port [$3D4] := 8;                              { pan smoothly the screen }
  Port [$3D5] := (Port [$3D5] and $E0) or (i and $0F)    { position mod 16 }
End;

Procedure Raster (var buf, buf2);
begin
  asm
    CLI
    push ds
    lds si, buf
    les di, buf2
    mov cx, 390
    @loop:
     xor al, al
     mov dx, 3c8h
     out dx, al
     inc dx
     mov ah, es:[di]
     inc di
     xor al, al
     out dx, al
     out dx, al
     lodsb
     out dx, al
     {----}
     dec dx
     mov al, 7
     out dx, al
     inc dx
     mov al, ah
     out dx, al
     out dx, al
     out dx, al
     {----}
     mov dx, 3dah
     @w1:
      in al, dx
      test al, 1
     jz @w1
     @w2:
      in al, dx
      test al, 1
     jnz @w2

     dec cx
    jnz @loop
    pop ds
    STI
 end;
end;

Procedure WriteLine (y : Integer; s : String);
var
   i   : Integer;
   Col : Byte;

Begin
   col := 7;
   For i := 1 to Length (s) do Begin
     Screen [y, i, 0] := Byte (s [i]);
     Screen [y, i, 1] := Col;
   End;
   If Length(s) < 80 then For i := Length (s)+1 to 80 do Begin
     Screen [y, i, 0] := 32;
     Screen [y, i, 1] := Col;
   End;
End;

Begin
  InitKeyboard;
  TextMode (co80);
  Pos  := 0;
  i    := 0;
  Vel  := 0;
  Time := 0;
  Bool := 1;
  For x := 0 to 199 do Begin
    rpal [x] := round(sqr(x/3.3)/64);
  end;
  For x := 0 to 199 do Begin
    rpal [x+200] := round(sqr(63-x/3.3)/64);
  end;
  For x := 0 to 199 do Begin
    rpal2 [x] := 63-round(x/3.3);
  end;
  For x := 0 to 199 do Begin
    rpal2 [x+200] := round(x/3.3);
  end;
  assign (f, 'stareach.nfo');
  reset (f);
  lines := 1;
  while not eof(f) do begin
    readln (f, s);
    writeline (lines, s);
    inc(lines);
  end;
  close (f);
  Lines := 800;
  PanScreen (Pos);
  Repeat
    k := Keycode;
    Case k of
      72: Dec (Vel, 8);
      80: Inc (Vel, 8);
    End;
    If (Vel > 0) then Dec (Vel, 6) else if (Vel < 0) then Inc (Vel, 6);
    Inc (Pos, Vel div 8);
    If Pos < 0 then Pos := 0
      else If (Pos > (Lines-26) shl 4) then Pos := (Lines-26) shl 4;
    Raster (rpal2, rpal);                              { display the raster }
    PanScreen (Pos);
  Until (k = 1);
  Fillchar (RPal2, 400, 0);
  For x := 0 to 399 div 6 do begin
    For y := 1 to 6 do begin
     Move (RPal [1], Rpal [0], 399); Rpal2 [399] := 0;
    End;
    Raster (rpal2, rpal);
    While (Port [$3DA] and 8) = 8 do;
    While (Port [$3DA] and 8) <> 8 do;
  end;
  Asm
    mov  ax, 03
    int  10h
  End;
  Restorekeyboard;
  Writeln ('Coded by BoRZoM');
End.
